/*************************\
*  Efsane 0.5.11          *
*  Pencere Boyama Modulu  *
\*************************/

#include <X11/Xlib.h>
#include <stdio.h>
#include <stdlib.h>

#include "turkpy.h"

int k1,y1,m1,k2,y2,m2,w,h,tip;
Window handle;
unsigned short maskeR[256],maskeG[256],maskeB[256];
int ofsetR,ofsetG,ofsetB;
  
void boyama_init(void)   // Boyama komutlari icin acilista yapilacaklar...
{
 int say;
 unsigned long maske1;
 ofsetR=ofsetG=ofsetB=0;
 switch (gorsellik->c_class)
 {
  case TrueColor:
   maske1=gorsellik->red_mask;
   while (!(maske1 & 1))
   {
    ofsetR++;
    maske1>>=1;
   }
   for (say=0;say<256;say++)
    maskeR[say]=(say*maske1+0x7f)/0xff;
   maske1=gorsellik->green_mask;
   while (!(maske1 & 1))
   {
    ofsetG++;
    maske1>>=1;
   }
   for (say=0;say<256;say++)
    maskeG[say]=(say*maske1+0x7f)/0xff;
   maske1=gorsellik->blue_mask;
   while (!(maske1 & 1))
   {
    ofsetB++;
    maske1>>=1;
   }
   for (say=0;say<256;say++)
    maskeB[say]=(say*maske1+0x7f)/0xff;
   break;
  default:
   fprintf(stderr,"903   Hata: Taninmayan renk sinifi...\n");
 }
}

void kenarlar(Pixmap veri,GC gc)
{
 XColor renk;
 renk.red=k1+(k1 >> 1);
 if (renk.red>=0xff) renk.red=0xffff;
 else renk.red*=0xff;
 renk.green=y1+(y1 >> 1);
 if (renk.green>=0xff) renk.green=0xffff;
 else renk.green*=0xff;
 renk.blue=m1+(m1 >> 1);
 if (renk.blue>=0xff) renk.blue=0xffff;
 else renk.blue*=0xff;
 XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
 XSetForeground(dpy,gc,renk.pixel);
 switch (tip)
 {
  case 0:
   XDrawLine(dpy,veri,gc,0,0,0,turkpy.ana_pencere.ozellik_pencere.height);
   XDrawLine(dpy,veri,gc,0,0,turkpy.ana_pencere.ozellik_pencere.width-17,0);
   break;
  case 1:
   XDrawLine(dpy,veri,gc,0,0,0,turkpy.ana_pencere.ozellik_pencere.height);
   break;
 }
 renk.red=(k1 >> 2)+(k1 >> 1);
 renk.red*=0xff;
 renk.green=(y1 >> 2)+(y1 >> 1);
 renk.green*=0xff;
 renk.blue=(m1 >> 2)+(m1 >> 1);
 renk.blue*=0xff;
 XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
 XSetForeground(dpy,gc,renk.pixel);
 switch (tip)
 {
  case 0:
   XDrawLine(dpy,veri,gc,0,h-1,w,h-1);
   XDrawLine(dpy,veri,gc,w-1,0,w-1,h);
   break;
  case 1:
   XDrawLine(dpy,veri,gc,0,0,w,0);
   XDrawLine(dpy,veri,gc,w-1,0,w-1,h);
   break;
 }
}

Pixmap boya_TrueColor(void)
{
 Pixmap veri;
 XImage *veri2;
 GC gc;
 float artk,arty,artm,k=k1,y=y1,m=m1;
 int say,say2;
 unsigned long pixel;
 unsigned char *veri3,*veri3yed,*veri3yed2;

 veri=XCreatePixmap(dpy,handle,w,h,derinlik);
 veri2=XCreateImage(dpy,gorsellik,derinlik,ZPixmap,0,0,w,h,32,0);
 if ((veri3=(unsigned char *) malloc(veri2->bytes_per_line*h))==NULL)
 {
  fprintf(stderr,"904   Hata: Hafiza yetersiz...\n");
  XDestroyImage(veri2);
  return veri;
 }

 veri3yed2=veri3yed=veri3;
 artk=(float)(k2-k1)/(tip ? h : w);
 arty=(float)(y2-y1)/(tip ? h : w);
 artm=(float)(m2-m1)/(tip ? h : w);
 for (say2=0;say2<h;say2++)
 {
  if (!tip)
  {
   k=k1;y=y1;m=m1;
  }
  for (say=0;say<w;say++)
  {
   pixel=(maskeR[(int)k]<<ofsetR) | (maskeG[(int)y]<<ofsetG) | (maskeB[(int)m]<<ofsetB);
   switch (veri2->byte_order)
   {
    case LSBFirst:
     *(veri3yed++)=pixel;
     switch (veri2->bits_per_pixel)
     {
      case 32:
       *(veri3yed++)=pixel >> 8;
       *(veri3yed++)=pixel >> 16;
       *(veri3yed++)=pixel >> 24;
       break;
      case 24:
       *(veri3yed++)=pixel >> 8;
       *(veri3yed++)=pixel >> 16;
       break;
      case 16:
       *(veri3yed++)=pixel >> 8;
       break;
     }
     break;
    case MSBFirst:
     switch (veri2->bits_per_pixel)
     {
      case 32:
       *(veri3yed++)=pixel >> 24;
      case 24:
       *(veri3yed++)=pixel >> 16;
      case 16:
       *(veri3yed++)=pixel >> 8;
      default:
       *(veri3yed++)=pixel;
     }
     break;
   }
   if (!tip)
   {
    k+=artk;y+=arty;m+=artm;
   }
  }
  veri3yed=veri3yed2+=veri2->bytes_per_line;
  if (tip)
  {
   k+=artk;y+=arty;m+=artm;
  }
 }
 veri2->data=(char *) veri3;

 gc=XCreateGC(dpy,veri,0,NULL);
 XPutImage(dpy,veri,gc,veri2,0,0,0,0,w,h);
 XDestroyImage(veri2);

 if (tip<2)
  kenarlar(veri,gc);
 XFreeGC(dpy,gc);

 return veri;
}

Pixmap boya_standart(void)
{
 Pixmap veri;
 GC gc;
 float artk,arty,artm,k=k1,y=y1,m=m1;
 int say;
 XColor renk;

 veri=XCreatePixmap(dpy,handle,w,h,derinlik);
 gc=XCreateGC(dpy,veri,0,NULL);
 artk=(float)(k2-k1)/(tip ? h : w);
 arty=(float)(y2-y1)/(tip ? h : w);
 artm=(float)(m2-m1)/(tip ? h : w);
 for (say=0;say<(tip ? h : w);say++)
 {
  renk.red=(unsigned int)k*0xff;
  renk.green=(unsigned int)y*0xff;
  renk.blue=(unsigned int)m*0xff;
  XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
  k+=artk;y+=arty;m+=artm;
  XSetForeground(dpy,gc,renk.pixel);
  switch (tip)
  {
   case 1:
   case 3:
    XDrawLine(dpy,veri,gc,0,say,w,say);
    XDrawPoint(dpy,veri,gc,0,say);
    break;
   case 0:
    XDrawLine(dpy,veri,gc,say,0,say,h);
    XDrawPoint(dpy,veri,gc,say,0);
    break;
  }
 }
 if (tip<2)
  kenarlar(veri,gc);
 XFreeGC(dpy,gc);

 return veri;
}

Pixmap boya_tonlu(void)
{
 switch (gorsellik->c_class)
 {
  case TrueColor:
   return boya_TrueColor();
  default:
   return boya_standart();
 }
}

Pixmap boya_tonsuz(void)
{
 Pixmap veri;
 GC gc;
 XColor renk;
 renk.red=(unsigned int)k1*0xff;
 renk.green=(unsigned int)y1*0xff;
 renk.blue=(unsigned int)m1*0xff;
 XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
 veri=XCreatePixmap(dpy,handle,w,h,derinlik);
 gc=XCreateGC(dpy,veri,0,NULL);
 XSetForeground(dpy,gc,renk.pixel);
 XFillRectangle(dpy,veri,gc,0,0,w,h);
 if (tip<2)
 {
  renk.red=k1+(k1 >> 1);
  if (renk.red>=0xff) renk.red=0xffff;
  else renk.red*=0xff;
  renk.green=y1+(y1 >> 1);
  if (renk.green>=0xff) renk.green=0xffff;
  else renk.green*=0xff;
  renk.blue=m1+(m1 >> 1);
  if (renk.blue>=0xff) renk.blue=0xffff;
  else renk.blue*=0xff;
  XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
  XSetForeground(dpy,gc,renk.pixel);
  switch (tip)
  {
   case 0:
    XDrawLine(dpy,veri,gc,0,0,0,turkpy.ana_pencere.ozellik_pencere.height);
    XDrawLine(dpy,veri,gc,0,0,turkpy.ana_pencere.ozellik_pencere.width-17,0);
    break;
   case 1:
    XDrawLine(dpy,veri,gc,0,0,0,turkpy.ana_pencere.ozellik_pencere.height);
    break;
  }
  renk.red=(k1 >> 2)+(k1 >> 1);
  renk.red*=0xff;
  renk.green=(y1 >> 2)+(y1 >> 1);
  renk.green*=0xff;
  renk.blue=(m1 >> 2)+(m1 >> 1);
  renk.blue*=0xff;
  XAllocColor(dpy,turkpy.ana_pencere.ozellik_pencere.colormap,&renk);
  XSetForeground(dpy,gc,renk.pixel);
  switch (tip)
  {
   case 0:
    XDrawLine(dpy,veri,gc,0,h-1,w,h-1);
    XDrawLine(dpy,veri,gc,w-1,0,w-1,h);
    break;
   case 1:
    XDrawLine(dpy,veri,gc,0,0,w,0);
    XDrawLine(dpy,veri,gc,w-1,0,w-1,h);
    break;
  }
 }
 XFreeGC(dpy,gc);
 return veri;
}

Pixmap boya(int w1,int h1,Window handle1,int tip1,int tip2)
{
 Pixmap pix1,pix2;
 XpmAttributes xpmatt;
 int tonlama;
 char *dosya;
 handle=handle1;tip=tip1;w=w1;h=h1;
 switch (tip2)
 {
  case 0:
   k1=turkpy.apr[0][0];y1=turkpy.apr[0][1];m1=turkpy.apr[0][2];
   k2=turkpy.apr[1][0];y2=turkpy.apr[1][1];m2=turkpy.apr[1][2];
   tonlama=turkpy.apt;
   dosya=turkpy.apd_isim;
   break;
  case 1:
   k1=turkpy.ppr[0][0];y1=turkpy.ppr[0][1];m1=turkpy.ppr[0][2];
   k2=turkpy.ppr[1][0];y2=turkpy.ppr[1][1];m2=turkpy.ppr[1][2];
   tonlama=turkpy.ppt;
   dosya=turkpy.ppd_isim;
   break;
  case 2:
   k1=turkpy.mur[0][0];y1=turkpy.mur[0][1];m1=turkpy.mur[0][2];
   k2=turkpy.mur[1][0];y2=turkpy.mur[1][1];m2=turkpy.mur[1][2];
   tonlama=turkpy.mut;
   dosya=turkpy.mud_isim;
   break;
 }
 switch (tonlama)
 {
  case 0:
   return boya_tonsuz();
  case 1:
   return boya_tonlu();
  case 2:
   xpmatt.valuemask=0;
   XReadPixmapFile(dpy,handle,dosya,&pix1,&pix2,&xpmatt);
   return pix1;
 }
}

