/****************\
*  Efsane 0.5.0  *
*  Ikon Modulu   *
\****************/

#include <X11/Xlib.h>
#include <stdio.h>

#include "turkpy.h"

int pencere_goster(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Ikon *ikon;
 menu_kapat(baslik,handle);
 ikon=turkpy.menu_bul_parent_ikon(handle);
 if (ikon==NULL) return 0;
 wind=turkpy.pencere_bul(ikon->sahip);
 if (wind!=NULL)
  XMapWindow(dpy,wind->alt_kisim);
 turkpy.durdur();
 XDestroyWindow(dpy,ikon->handle);
 XDestroyWindow(dpy,ikon->handle2);
 turkpy.ikon_oldur(ikon->handle);
 turkpy.harekete_gec();
}

int pencere_kapat_ikon(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 TurkPY_Ikon *ikon;
 menu_kapat(baslik,handle);
 ikon=turkpy.menu_bul_parent_ikon(handle);
 if (ikon==NULL) return 0;
 turkpy.durdur();
 XDestroyWindow(dpy,ikon->handle);
 XDestroyWindow(dpy,ikon->handle2);
 turkpy.ikon_oldur(ikon->handle);
 turkpy.harekete_gec();
 wind=turkpy.pencere_bul(ikon->sahip);
 if (wind!=NULL)
 {
  XMapWindow(dpy,wind->alt_kisim);
  tus=turkpy.tus_bul(wind->tuslar[1]);
  if (tus!=NULL)
   tus->tusa_bas(2);
 }
}

int pencere_oldur_ikon(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 TurkPY_Ikon *ikon;
 menu_kapat(baslik,handle);
 ikon=turkpy.menu_bul_parent_ikon(handle);
 if (ikon==NULL) return 0;
 turkpy.durdur();
 XDestroyWindow(dpy,ikon->handle);
 XDestroyWindow(dpy,ikon->handle2);
 turkpy.ikon_oldur(ikon->handle);
 turkpy.harekete_gec();
 wind=turkpy.pencere_bul(ikon->sahip);
 if (wind!=NULL)
  XKillClient(dpy,wind->alt_kisim);
}

ikon_menu_olustur(TurkPY_Ikon *penc)
{
 char temp[100];
 penc->menu.ilk_komut=NULL;
 penc->menu.komut_ekle(yazi_al("PENC_SHOW"),"",&pencere_goster);
 penc->menu.komut_ekle(yazi_al("PENC_KAPAT"),"",&pencere_kapat_ikon);
 sprintf(temp,"%s ->",yazi_al("UYGULAMALAR"));
 penc->menu.komut_ekle(temp,"uygugoster",&favoriler);
 penc->menu.komut_ekle(yazi_al("PENC_OLDUR"),"",&pencere_oldur_ikon);
 penc->menu.sonlandir();
}

TurkPY_Ikon::init(Window sah,int ikonsay,int x,int y)
{
 TurkPY_Pencere *wind;
 XGCValues gecici1;
 menu.menu_ekranda=False;
 sahip=sah;
 son_bas=0;
 wind=turkpy.pencere_bul(sahip);
 if (wind!=NULL)
  XUnmapWindow(dpy,wind->alt_kisim);
 wind=turkpy.pencere_bul(wind->pencereler[0]);
 if (wind!=NULL)
 {
  sscanf(wind->baslik,"%s",isim);
  isim_uzun=XTextWidth(stdfnt,isim,strlen(isim));
  if (isim_uzun>ikon_boyu)
   isim_uzun=ikon_boyu;
 }
 turkpy.durdur();
 handle=XCreateSimpleWindow(dpy,kok_pencere,0,0,ikon_boyu-4,ikon_boyu-40,0,beyaz,siyah);
 handle2=XCreateSimpleWindow(dpy,kok_pencere,0,0,40,30,0,beyaz,siyah);
 XSelectInput(dpy,handle,ExposureMask | ButtonPressMask | ButtonReleaseMask | ButtonMotionMask);
 XSelectInput(dpy,handle2,ExposureMask | ButtonPressMask | ButtonReleaseMask | ButtonMotionMask);
 XReparentWindow(dpy,handle,turkpy.ana_pencere.handle,x+2,y+35);
 XReparentWindow(dpy,handle2,turkpy.ana_pencere.handle,x+(ikon_boyu-40)/2,y);
 XGetWindowAttributes(dpy,handle,&ozellik_pencere);
 ozellik_pencere.x=x;
 ozellik_pencere.y=y;
 XSetWindowBackground(dpy,handle,turkpy.ikon_arka_plan);
 XSetWindowBackgroundPixmap(dpy,handle2,ikon_resim);
 XMapWindow(dpy,handle);
 XMapWindow(dpy,handle2);
 gecici1.font=stdfnt->fid;
 gc_pencere=XCreateGC(dpy,handle,GCFont,&gecici1);
 turkpy.harekete_gec();
 ikon_menu_olustur(this);
 XFlush(dpy);
}

TurkPY_Ikon::paint(void)
{
 XClearWindow(dpy,handle);
 XClearWindow(dpy,handle2);
 if (isim[0])
 {
  XSetForeground(dpy,gc_pencere,beyaz);
  XDrawString(dpy,handle,gc_pencere,(ikon_boyu-isim_uzun-4)/2,17,isim,strlen(isim));
 }
}

void TurkPY_Ikon::tekrar_yerlestir(int ikonsay)
{
 int x,y;
 x=(ikonsay%turkpy.ikon_satir)*ikon_boyu;
 y=turkpy.ana_pencere.ozellik_pencere.height-(((ikonsay/turkpy.ikon_satir)+1)*64);
 yerlestir(x,y);
}

void TurkPY_Ikon::yerlestir(int x,int y)
{
 turkpy.durdur();
 XMoveWindow(dpy,handle,x+2,y+35);
 XMoveWindow(dpy,handle2,x+(ikon_boyu-40)/2,y);
 XGetWindowAttributes(dpy,handle,&ozellik_pencere);
 ozellik_pencere.x=x;
 ozellik_pencere.y=y;
 turkpy.harekete_gec();
}

void TurkPY_Ikon::tusa_bas(Time zaman)
{
 TurkPY_Pencere *wind;
 if (!son_bas)
  son_bas=zaman;
 else
 {
  if (zaman-son_bas>turkpy.cift_klik)
   son_bas=zaman;
  else
  {
   wind=turkpy.pencere_bul(sahip);
   if (wind!=NULL)
    XMapWindow(dpy,wind->alt_kisim);
   turkpy.durdur();
   XDestroyWindow(dpy,handle);
   XDestroyWindow(dpy,handle2);
   turkpy.ikon_oldur(handle);
   turkpy.harekete_gec();
  }
 }
}

