/****************\
*  Efsane 0.6.0  *
*  Menu Modulu   *
\****************/

#include <X11/Xlib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "turkpy.h"

TurkPY_Menu::init(int xx,int yy)
{
 TurkPY_Menu_Komutu *komut;
 int komutsay=0;
 if (menu_ekranda)
  return -1;
 x=xx;
 y=yy;
 w=0;
 menu_ekranda=True;
 turkpy.durdur();
 komut=ilk_komut;
 while (komut!=NULL)
 {
  komutsay++;
  if (XTextWidth(stdfnt,komut->baslik,strlen(komut->baslik))>w)
   w=XTextWidth(stdfnt,komut->baslik,strlen(komut->baslik));
  komut=komut->sonraki;
 }
 if (komutsay==0)
  return -1;
 w+=15;
 if (y+komutsay*menu_boyut_h>turkpy.ana_pencere.ozellik_pencere.height)
  y-=komutsay*menu_boyut_h;
 handle=XCreateSimpleWindow(dpy,kok_pencere,x,y,w,komutsay*menu_boyut_h,0,beyaz,siyah);
 XSelectInput(dpy,handle,StructureNotifyMask | ExposureMask | SubstructureRedirectMask);
 XReparentWindow(dpy,handle,turkpy.ana_pencere.handle,x,y);
 XMapWindow(dpy,handle);
 menu_arka_plan1=boya(w,menu_boyut_h,handle,0,1);
 menu_arka_plan2=boya(w,menu_boyut_h,handle,0,0);
 komutsay=0;
 komut=ilk_komut;
 while (komut!=NULL)
 {
  komut->baba=handle;
  komut->arka_plan1=menu_arka_plan1;
  komut->arka_plan2=menu_arka_plan2;
  komut->init(komutsay,w);
  komut=komut->sonraki;
  komutsay++;
 }
 turkpy.harekete_gec();
}

int alt_menu(char *baslik,Window handle)
{
 TurkPY_Menu *menu,*menu_kendi;
 menu=turkpy.menu_bul_ust(handle);
 if (menu!=NULL)
  menu_kapat("",menu->handle);
 menu=turkpy.menu_bul_isim(baslik);
 menu_kendi=turkpy.menu_bul(handle);
 if (menu!=NULL && menu_kendi!=NULL)
 {
  menu->init(menu_kendi->x+menu_kendi->w,menu_kendi->y+turkpy.menu_komut_say(menu_kendi,baslik)*menu_boyut_h);
  menu->ust_menu=menu_kendi->handle;
 }
}

void TurkPY_Menu::komut_ekle(char *baslik,char *baslik2,tusa_bas_fonk tusa_bas1)
{
 TurkPY_Menu_Komutu *komut,*onceki;
 onceki=NULL;
 komut=ilk_komut;
 while (komut!=NULL)
 {
  onceki=komut;
  komut=komut->sonraki;
 }
 komut=(TurkPY_Menu_Komutu *) malloc(sizeof(TurkPY_Menu_Komutu));
 komut->sonraki=NULL;
 if (onceki!=NULL)
  onceki->sonraki=komut;
 else
  ilk_komut=komut;
 strcpy(komut->baslik,baslik);
 strcpy(komut->calis_baslik,baslik2);
 komut->tusa_bas=tusa_bas1;
 komut->otomatik=(tusa_bas1==&alt_menu || tusa_bas1==&favoriler) ? True : False;
 turkpy.komut_yarat(komut);
}

void menu_kapat2(TurkPY_Menu *menu)
{
 TurkPY_Menu_Komutu *komut;
 TurkPY_Menu *menu2;
 menu2=turkpy.menu_bul(menu->ust_menu);
 if (menu2!=NULL && menu2->menu_ekranda)
  menu_kapat2(menu2);
 turkpy.durdur();
 komut=menu->ilk_komut;
 while (komut!=NULL)
 {
  if (komut->mapped)
  {
   XDestroyWindow(dpy,komut->handle);
   komut->mapped=False;
  }
  komut=komut->sonraki;
 }
 if (menu->menu_ekranda)
 {
  XDestroyWindow(dpy,menu->handle);
  menu->menu_ekranda=False;
 }
 turkpy.harekete_gec();
}

int menu_kapat(char *baslik,Window handle)
{
 TurkPY_Menu_Komutu *komut;
 TurkPY_Menu *menu;
 menu=turkpy.menu_bul_ust(handle);
 if (menu!=NULL)
  menu_kapat("",menu->handle);
 menu=turkpy.menu_bul(handle);
 if (menu==NULL)
  return -1;
 turkpy.durdur();
 komut=menu->ilk_komut;
 while (komut!=NULL)
 {
  if (komut->mapped)
  {
   XDestroyWindow(dpy,komut->handle);
   komut->mapped=False;
  }
  komut=komut->sonraki;
 }
 if (menu->menu_ekranda)
 {
  XDestroyWindow(dpy,handle);
  menu->menu_ekranda=False;
 }
 turkpy.harekete_gec();
}

void TurkPY_Menu::sonlandir(void)
{
 komut_ekle(yazi_al("MENU_KAPAT"),"",&menu_kapat);
}

TurkPY_Menu_Komutu::init(int sira,int w)
{
 int y=sira*menu_boyut_h;
 wid=w;
 XGCValues gecici1;
 handle=XCreateSimpleWindow(dpy,kok_pencere,0,y,w,menu_boyut_h,0,beyaz,siyah);
 XSelectInput(dpy,handle,StructureNotifyMask | ExposureMask | ButtonReleaseMask |
    LeaveWindowMask | EnterWindowMask | ButtonPressMask);
 XReparentWindow(dpy,handle,baba,0,y);
 XSetWindowBackgroundPixmap(dpy,handle,arka_plan1);
 XMapWindow(dpy,handle);
 gecici1.font=stdfnt->fid;
 gc_pencere=XCreateGC(dpy,handle,GCFont,&gecici1);
 mapped=True;
 uzerinde=False;
}

void TurkPY_Menu_Komutu::durum_degis(Bool neye)
{
 TurkPY_Menu *menu;
 if (!mapped) return;
 if (uzerinde && !neye)
 {
  uzerinde=False;
  XSetWindowBackgroundPixmap(dpy,handle,arka_plan1);
  XClearWindow(dpy,handle);
 }
 else
 if (!uzerinde && neye)
 {
  uzerinde=True;
  XSetWindowBackgroundPixmap(dpy,handle,arka_plan2);
  XClearWindow(dpy,handle);
  menu=turkpy.menu_bul_ust(baba);
  if (menu!=NULL)
   menu_kapat("",menu->handle);
  if (otomatik)
   tusa_bas(calis_baslik,baba);
 }
 paint();
}

TurkPY_Menu_Komutu::paint(void)
{
 if (!mapped) return -1;
 XSetForeground(dpy,gc_pencere,beyaz);
 if (!strcmp(baslik+strlen(baslik)-2,"->"))
 {
  XDrawString(dpy,handle,gc_pencere,3,menu_boyut_h-3,baslik,strlen(baslik)-3);
  XDrawLine(dpy,handle,gc_pencere,wid-10,5,wid-10,menu_boyut_h-5);
  XDrawLine(dpy,handle,gc_pencere,wid-10,5,wid-5,menu_boyut_h/2);
  XDrawLine(dpy,handle,gc_pencere,wid-10,menu_boyut_h-5,wid-5,menu_boyut_h/2);
 }
 else
  XDrawString(dpy,handle,gc_pencere,3,menu_boyut_h-3,baslik,strlen(baslik));
}

