/******************\
*  Efsane 0.6.0    *
*  Pencere Modulu  *
\******************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "turkpy.h"

#define kalinlik 20

XSetWindowAttributes ozellik2;
pencere_liste_tipi *gecici_liste_2;
typedef struct wmhints_tipi
{
 unsigned long fonkdeko,fonksiyon,dekorasyon;
};

int favoriler(char *baslik,Window handle)
{
 TurkPY_Menu *menu;
 menu=turkpy.menu_bul(handle);
 if (menu==NULL) return -1;
 favoriler_menu.ust_menu=handle;
 favoriler_menu.init(menu->x+menu->w,menu->y+turkpy.menu_komut_say(menu,baslik)*menu_boyut_h);
}

int efsane_kapat(char *baslik,Window handle)
{
 shutdown=True;
}

int pencere_oldur(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 menu_kapat(baslik,handle);
 wind=turkpy.menu_bul_parent(handle);
 if (wind!=NULL)
  XKillClient(dpy,wind->alt_kisim);
}

int pencere_kapat(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 menu_kapat(baslik,handle);
 wind=turkpy.menu_bul_parent(handle);
 if (wind!=NULL)
 {
  tus=turkpy.tus_bul(wind->tuslar[1]);
  if (tus!=NULL)
   tus->tusa_bas(2);
 }
}

int pencere_buyut(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 menu_kapat(baslik,handle);
 wind=turkpy.menu_bul_parent(handle);
 if (wind!=NULL)
 {
  tus=turkpy.tus_bul(wind->tuslar[3]);
  if (tus!=NULL)
   tus->tusa_bas(2);
 }
}

int pencere_kucult(char *baslik,Window handle)
{
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 menu_kapat(baslik,handle);
 wind=turkpy.menu_bul_parent(handle);
 if (wind!=NULL)
 {
  tus=turkpy.tus_bul(wind->tuslar[2]);
  if (tus!=NULL)
   tus->tusa_bas(2);
 }
}

menu_olustur(TurkPY_Pencere *penc,Bool maximize,Bool minimize)
{
 char temp[100];
 penc->menu.ilk_komut=NULL;
 penc->menu.komut_ekle(yazi_al("PENC_KAPAT"),"",&pencere_kapat);
 if (maximize)
  penc->menu.komut_ekle(yazi_al("PENC_MAX"),"",&pencere_buyut);
 if (minimize)
  penc->menu.komut_ekle(yazi_al("PENC_MIN"),"",&pencere_kucult);
 sprintf(temp,"%s ->",yazi_al("UYGULAMALAR"));
 penc->menu.komut_ekle(temp,"uygugoster",&favoriler);
 penc->menu.komut_ekle(yazi_al("PENC_OLDUR"),"",&pencere_oldur);
 penc->menu.sonlandir();
}

TurkPY_Pencere::init(int x,int y,int w,int h,Window hand,int tip)
{
 int saydir;
 XGCValues gecici1;
 turkpy.durdur();
 menu.menu_ekranda=maxed=False;
 handle=XCreateSimpleWindow(dpy,kok_pencere,x,y,w,h,0,beyaz,siyah);
 XGetWindowAttributes(dpy,handle,&ozellik_pencere);
 XSelectInput(dpy,handle,StructureNotifyMask | ExposureMask | ButtonMotionMask |
    ButtonPressMask | ButtonReleaseMask | PointerMotionMask | SubstructureRedirectMask |
    FocusChangeMask);
 if (baba)
 {
  son_focus=0;
  alt_kisim=hand;
  XReparentWindow(dpy,handle,turkpy.ana_pencere.handle,x,y);
 }
 else
 {
  alt_kisim=None;
  XReparentWindow(dpy,handle,hand,x,y);
  for (saydir=0;saydir<2;saydir++)
   pencereler[saydir]=None;
  arka_plan1=boya(ozellik_pencere.width,ozellik_pencere.height,handle,tip,0);
  arka_plan2=boya(ozellik_pencere.width,ozellik_pencere.height,handle,tip,1);
  XSetWindowBackgroundPixmap(dpy,handle,arka_plan1);
 }
 mapped=True;
 gecici1.font=stdfnt->fid;
 gc_pencere=XCreateGC(dpy,handle,GCFont,&gecici1);
 prog_penceresi=False;
 for (saydir=0;saydir<5;saydir++)
  tuslar[saydir]=None;
 focus=True;
 turkpy.harekete_gec();
 XFlush(dpy);
}

void TurkPY_Pencere::tekrar_boya(void)
{
 if (!baba) return;
 int say;
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 for (say=0;say<5;say++)
  if (tuslar[say]!=None)
  {
   tus=turkpy.tus_bul(tuslar[say]);
   if (tus!=NULL)
   {
    XSetWindowBackgroundPixmap(dpy,tus->handle,focus ? turkpy.tus_arka_plan1 : turkpy.tus_arka_plan2);
    XClearWindow(dpy,tus->handle);
    tus->paint();
   }
  }
 for (say=0;say<2;say++)
 {
  wind=turkpy.pencere_bul(pencereler[say]);
  if (wind!=NULL)
  {
   XSetWindowBackgroundPixmap(dpy,wind->handle,focus ? wind->arka_plan1 : wind->arka_plan2);
   XClearWindow(dpy,wind->handle);
   wind->paint();
  }
 }
}

TurkPY_Pencere::initprog(Window hand)
{
 Atom wm_hints,ret1;
 XSizeHints boyut_ayar;
 TurkPY_Pencere *penc,*penc2;
 Window transwin,grupwin;
 XEvent olay;
 char *isim;
 XWMHints *grup_ayar;
 int ret2,x,y,minw,minh,maxw,maxh;
 unsigned long ret3,ret4;
 long ret5;
 wmhints_tipi wm_hint;
 turkpy.durdur();
 baba=False;
 handle=hand;
 if (!turkpy.kontrol_et(handle,True))
  return -1;
 if (!XGetWindowAttributes(dpy,handle,&ozellik_pencere))
 {
  turkpy.harekete_gec();
  return -1;
 }
 if (ozellik_pencere.x+ozellik_pencere.width>ozellik_kok_pencere.width-21)
  ozellik_pencere.x=ozellik_kok_pencere.width-21-ozellik_pencere.width;
 if (ozellik_pencere.y+ozellik_pencere.height>ozellik_kok_pencere.height-21)
  ozellik_pencere.y=ozellik_kok_pencere.height-21-ozellik_pencere.height;
 ozellik_pencere.height+=ozellik_pencere.border_width*2;
 ozellik_pencere.width+=ozellik_pencere.border_width*2;
 penc=turkpy.kendin_pencere_yarat(ozellik_pencere.x,ozellik_pencere.y,ozellik_pencere.width+20,ozellik_pencere.height+20,handle,True,0);
 XChangeSaveSet(dpy,handle,SetModeInsert);
 XReparentWindow(dpy,handle,penc->handle,1,1);
 resize=maximize=minimize=True;
 grup_ayar=XGetWMHints(dpy,handle);
 if ((grup_ayar) && (grup_ayar->flags & WindowGroupHint))
  grupwin=grup_ayar->window_group;
 else grupwin=None;
 if (XGetWMNormalHints(dpy,handle,&boyut_ayar,&ret5))
 {
  if (boyut_ayar.flags & PMinSize)
  {
   penc->minsize=True;
   penc->minw=boyut_ayar.min_width+kalinlik;
   penc->minh=boyut_ayar.min_height+kalinlik;
  }
  else penc->minsize=False;
  if (boyut_ayar.flags & PMaxSize)
  {
   penc->maxsize=True;
   penc->maxw=boyut_ayar.max_width+kalinlik;
   penc->maxh=boyut_ayar.max_height+kalinlik;
  }
  else penc->maxsize=False;
 }
 else penc->minsize=penc->maxsize=False;
 trans=False;
 if (XGetTransientForHint(dpy,handle,&transwin))
 {
  if ((transwin && (transwin!=handle)) || (transwin==kok_pencere) || (transwin==grupwin))
   trans=True;
 }
 if (trans)
  minimize=maximize=resize=False;
 else
 if ((minsize) && (maxsize) && (maxh==minh) && (maxw==minw))
  maximize=resize=False;
 // Buralar Motif destegi icin...   // DIKKAT: Daha deneme asamasinda...
 wm_hints=XInternAtom(dpy,"_MOTIF_WM_HINTS",False);
 if (XGetWindowProperty(dpy,handle,wm_hints,0,3,False,wm_hints,&ret1,&ret2,&ret3,&ret4,(unsigned char **) &wm_hint)==Success)
 {
  if ((wm_hint.fonkdeko & fonk_hepsi) && (!(wm_hint.fonksiyon & fonk_hepsi)))
  {
   if (wm_hint.fonksiyon & fonk_resize)
    resize=True; else resize=False;
   if (wm_hint.fonksiyon & fonk_minimize)
    minimize=True; else minimize=False;
   if (wm_hint.fonksiyon & fonk_maximize)
    maximize=True; else maximize=False;
  }
  if ((wm_hint.fonkdeko & dekor_resize) && (!(wm_hint.dekorasyon & dekor_hepsi)))
  {
   if ((wm_hint.dekorasyon & dekor_resize) && (resize))
    resize=True; else resize=False;
   if ((wm_hint.dekorasyon & dekor_minimize) && (minimize))
    minimize=True; else minimize=False;
   if ((wm_hint.dekorasyon & dekor_maximize) && (maximize))
    maximize=True; else maximize=False;
  }
 }
 // Motif destegi burada bitiyor...
 menu_olustur(penc,maximize,minimize);
 x=1;
 y=ozellik_pencere.height+2;
 if (resize)
  {turkpy.tus_yarat(x,y,1,penc->handle);x+=18;}
 turkpy.tus_yarat(x,y,2,penc->handle);x+=18;
 if (minimize)
  {turkpy.tus_yarat(x,y,3,penc->handle);x+=18;}
 if (maximize)
  {turkpy.tus_yarat(x,y,4,penc->handle);x+=18;}
 turkpy.tus_yarat(x,y,5,penc->handle);x+=18;
 penc2=turkpy.kendin_pencere_yarat(x,y,penc->ozellik_pencere.width-x-1,17,penc->handle,False,0);
 penc->pencereler[0]=penc2->handle;
 isim=(char *) malloc(255);
 if (!XFetchName(dpy,handle,&isim))
  penc2->baslik[0]=0;
 else
  strcpy(penc2->baslik,isim);
 free(isim);
 penc2=turkpy.kendin_pencere_yarat(ozellik_pencere.width+2,1,17,ozellik_pencere.height+2,penc->handle,False,1);
 penc->pencereler[1]=penc2->handle;
 penc2->baslik[0]=0;
 XSelectInput(dpy,handle,StructureNotifyMask | PropertyChangeMask | FocusChangeMask);
 turkpy.harekete_gec();
 XMapWindow(dpy,penc->handle);
 XMapSubwindows(dpy,penc->handle);
 XFlush(dpy);
 prog_penceresi=True;
}

TurkPY_Pencere::paint(void)
{
 if (!baba)
  if (baslik[0])
  {
   XSetForeground(dpy,gc_pencere,beyaz);
   XDrawString(dpy,handle,gc_pencere,3,ozellik_pencere.height-3,baslik,strlen(baslik));
  }
 XFlush(dpy);
}

/*
TurkPY_AnaPencere
*/

TurkPY_AnaPencere::init(int w,int h)
{
 char temp[100];
 handle=XCreateSimpleWindow(dpy,kok_pencere,0,0,w,h,0,beyaz,siyah);
 XGetWindowAttributes(dpy,handle,&ozellik_pencere);
 XSelectInput(dpy,handle,StructureNotifyMask | ButtonReleaseMask | ExposureMask |
    PropertyChangeMask);
 arka_plan=boya(ozellik_pencere.width,ozellik_pencere.height,handle,3,2);
 XSetWindowBackgroundPixmap(dpy,handle,arka_plan);
 XMapWindow(dpy,handle);
 menu.ilk_komut=NULL;
 menu.komut_ekle("Efsane Yoneticisi","efsane_yonetici",&komut_calis);
 sprintf(temp,"%s ->",yazi_al("UYGULAMALAR"));
 menu.komut_ekle(temp,"uygugoster",&favoriler);
 menu.komut_ekle(yazi_al("IKON_DIZ"),"",&ikon_diz);
 menu.komut_ekle(yazi_al("OTURUM_KAPAT"),"",&efsane_kapat);
 menu.sonlandir();
 XReparentWindow(dpy,handle,kok_pencere,0,0);
 gc_pencere=XCreateGC(dpy,handle,0,NULL);
 XFlush(dpy);
}

TurkPY_AnaPencere::paint(void)
{
 if (bilgi_goster)
 {
  XSetForeground(dpy,gc_pencere,beyaz);
  XDrawString(dpy,handle,gc_pencere,0,ozellik_pencere.height,infostr,infolen);
 }
 XFlush(dpy);
}

