/*****************\
*  Efsane 0.6.0   *
*  Sistem Modulu  *
\*****************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xresource.h>
#include <X11/cursorfont.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "turkpy.h"

#define valmask (CWX | CWY | CWWidth | CWHeight)
#define ikonX gecici_ikon->penc.ozellik_pencere.x
#define ikonY gecici_ikon->penc.ozellik_pencere.y

unsigned long focus_say;
XWindowAttributes ozellik_kok_pencere;
pencere_liste_tipi *pencere_listesi,*gecici_liste;
tus_liste_tipi *tus_listesi,*gecici_tus;
ikon_liste_tipi *ikon_listesi,*gecici_ikon;
kisayol_liste_tipi *kisayol_listesi,*gecici_kisayol;
komut_liste_tipi *komut_listesi,*gecici_komut;
menu_liste_tipi *menu_listesi,*gecici_menu;
Bool shutdown,oynat,boyutlandir,boyutbasla;
int oncekix,oncekiy,yenix,yeniy,yaz,menu_boyut_h,uzaktan_durum,oynat_ikon;
int bilgi_goster;
char uzaktan_sifre[80],ikonlar_durum[50][50];
XWindowChanges degistir;
GC boyutGC;
TurkPY_Menu favoriler_menu;
TurkPY_Pencere *wind,*focus_pencere;
TurkPY_Tus *tus;
TurkPY_Ikon *ikon;
TurkPY_Kisayol *kisayol;
TurkPY_Menu_Komutu *menu_komut;
XFontStruct *stdfnt;
Atom atom_protokol,atom_yok_et,atom_durum_degis;
FILE *menu_dosya;
Pixmap ikon_resim;

void prog_calis(char *baslik)
{
 char *komut;
 komut=(char *) malloc(strlen(DisplayString(dpy))+strlen(baslik)+20);
 sprintf(komut,"DISPLAY=%s exec %s &",DisplayString(dpy),baslik);
 system(komut);
 free(komut);
}

TurkPY::init(void)
{
 // Fonksiyonda kullanilan degiskenler...
 char font[255];
 XGCValues gc_deger;
 Pixmap pix1,pix2;
 XpmAttributes xpmatt;
 XColor renk;
 // Pencere listesini yarat...
 pencere_listesi=(pencere_liste_tipi *) malloc(sizeof(pencere_liste_tipi));
 pencere_listesi->sonraki=NULL;
 // Kisayol listesini yarat...
 kisayol_listesi=(kisayol_liste_tipi *) malloc(sizeof(kisayol_liste_tipi));
 kisayol_listesi->sonraki=NULL;
 // Tus listesini yarat...
 tus_listesi=(tus_liste_tipi *) malloc(sizeof(tus_liste_tipi));
 tus_listesi->sonraki=NULL;
 // Ikon listesini yarat...
 ikon_listesi=(ikon_liste_tipi *) malloc(sizeof(ikon_liste_tipi));
 ikon_listesi->sonraki=NULL;
 // Komut listesini yarat...
 komut_listesi=(komut_liste_tipi *) malloc(sizeof(komut_liste_tipi));
 komut_listesi->sonraki=NULL;
 // Menu listesini yarat...
 menu_listesi=(menu_liste_tipi *) malloc(sizeof(menu_liste_tipi));
 menu_listesi->sonraki=NULL;
 // ~/.efsane.ayarlar ve ~/.efsane.menu dosyalarindan ayarlari yukle...
 verileri_yukle();
 lang_baslat(dil_isim);
 menu_yukle();
 // Fare kursorlerini yukle...
 normal_kursor=XCreateFontCursor(dpy,XC_left_ptr);
 hareket_kursor=XCreateFontCursor(dpy,XC_fleur);
 buyukluk_kursor=XCreateFontCursor(dpy,XC_bottom_left_corner);
 // Standart yazitipini yukle...
 strcpy(font,"-adobe-helvetica-medium-r-*-*-*-120-*-*-*-*-*-*");
 stdfnt=XLoadQueryFont(dpy,font);
 // Kok Pencerenin ayarlarini yap...
 XGetWindowAttributes(dpy,kok_pencere,&ozellik_kok_pencere);
 gc_deger.foreground=beyaz;
 gc_deger.function=GXxor;
 gc_deger.subwindow_mode=IncludeInferiors;
 gc_deger.font=stdfnt->fid;
 boyutGC=XCreateGC(dpy,kok_pencere,GCForeground | GCFont | GCFunction | GCSubwindowMode,&gc_deger);
 XSelectInput(dpy,kok_pencere,SubstructureRedirectMask);
 XDefineCursor(dpy,kok_pencere,normal_kursor);
 // Bir satira kac ikon sigabilecegi hesapla...
 ikon_satir=ozellik_kok_pencere.width/ikon_boyu-1;
 // Arka Plan penceresini yarat...
 ana_pencere.init(ozellik_kok_pencere.width,ozellik_kok_pencere.height);
 // Pencerelere gonderilen Atom'lari yukle...
 atom_protokol=XInternAtom(dpy,"WM_PROTOCOLS",False);
 atom_yok_et=XInternAtom(dpy,"WM_DELETE_WINDOW",False);
 atom_durum_degis=XInternAtom(dpy,"WM_CHANGE_STATE",False);
 // Tuslari boya...
 tus_arka_plan1=boya(tus_boyu,tus_boyu,ana_pencere.handle,0,0);
 tus_arka_plan2=boya(tus_boyu,tus_boyu,ana_pencere.handle,0,1);
 // Ikonlari boya...
 renk.red=ppr[0][0]*(unsigned int)0xff;
 renk.green=ppr[0][1]*(unsigned int)0xff;
 renk.blue=ppr[0][2]*(unsigned int)0xff;
 XAllocColor(dpy,ana_pencere.ozellik_pencere.colormap,&renk);
 ikon_arka_plan=renk.pixel;
 xpmatt.valuemask=0;
 XpmCreatePixmapFromData(dpy,ana_pencere.handle,ikon1_xpm,&pix1,&pix2,&xpmatt);
 ikon_resim=pix1;
 // Kisa yollari boya ve yukle...
 kisayol_arka_plan=boya(ikon_boyu,ikon_boyu,ana_pencere.handle,0,1);
 kisayol_yarat("Yonetici","efsane_yonetici","");
 kisayol_yukle();
 // Klavyenin hangi pencereye ait oldugunu ayarla...
 XSetInputFocus(dpy,PointerRoot,RevertToParent,CurrentTime);
 focus_pencere=NULL;
 focus_say=0;
 // Tampon bellegi bosalt...
 XFlush(dpy);
 // Uzaktan Kumanda Modulu'nu calistir...
 if (uzaktan_durum)
 {
  sprintf(font,"efsane_uzaktan %ld %s",ana_pencere.handle,uzaktan_sifre);
  prog_calis(font);
 }
}

int komut_calis(char *baslik,Window handle)
{
 TurkPY_Menu *menu,*menu2;
 menu=turkpy.menu_bul(handle);
 if (menu!=NULL)
 {
  menu2=turkpy.menu_bul_ust(menu->handle);
  menu_kapat2(menu);
  if (menu2!=NULL)
   menu_kapat(baslik,menu2->handle);
 }
 menu_kapat(baslik,handle);
 prog_calis(baslik);
}

void uzaktan_kum(void)
{
 char *isim,**argc,tip;
 int argv,say,yeni;
 TurkPY_Pencere *wind;
 TurkPY_Tus *tus;
 pencere_liste_tipi *gecici_liste;
 Window handle;
 isim=(char *) malloc(255);
 if (!XFetchName(dpy,turkpy.ana_pencere.handle,&isim))
  isim[0]=0;
 if (strlen(isim)>4)
 {
  isim[5]=0;
  if (!strcmp(isim,"oz_al"))
  {
   sscanf(isim+6," %ld",&handle);
   wind=turkpy.pencere_bul_parent(handle);
   if (wind!=NULL)
   {
    argv=5;
    argc=(char **) malloc(sizeof(char *)*argv);
    for (say=0;say<argv;say++)
     argc[say]=(char *) malloc(20);
    sprintf(argc[0],"X = %d",wind->ozellik_pencere.x);
    sprintf(argc[1],"Y = %d",wind->ozellik_pencere.y);
    sprintf(argc[2],"E = %d (en)",wind->ozellik_pencere.width);
    sprintf(argc[3],"B = %d (boy)",wind->ozellik_pencere.height);
    strcpy(argc[4],"tamam");
   }
   else
   {
    argv=1;
    argc=(char **) malloc(sizeof(char *)*argv);
    argc[0]=(char *) malloc(10);
    strcpy(argc[0],"iptal");
   }
  }
  else
  if (!strcmp(isim,"ozver"))
  {
   argv=1;
   argc=(char **) malloc(sizeof(char *)*argv);
   argc[0]=(char *) malloc(10);
   sscanf(isim+6," %ld %c %d",&handle,&tip,&yeni);
   wind=turkpy.pencere_bul_parent(handle);
   if (wind!=NULL)
   {
    if (tip=='X')
     turkpy.pencere_oynat(wind,yeni,wind->ozellik_pencere.x,wind->ozellik_pencere.y,wind->ozellik_pencere.y);
    if (tip=='Y')
     turkpy.pencere_oynat(wind,wind->ozellik_pencere.x,wind->ozellik_pencere.x,yeni,wind->ozellik_pencere.y);
    if (tip=='E')
     turkpy.pencere_boyut(wind,wind->ozellik_pencere.x,wind->ozellik_pencere.y,yeni,wind->ozellik_pencere.height,True);
    if (tip=='B')
     turkpy.pencere_boyut(wind,wind->ozellik_pencere.x,wind->ozellik_pencere.y,wind->ozellik_pencere.width,yeni,True);
    if (tip=='X' || tip=='Y' || tip=='E' || tip=='B')
     strcpy(argc[0],"tamam");
    else
     strcpy(argc[0],"iptal");
   }
   else
    strcpy(argc[0],"iptal");
  }
  else
  if (!strcmp(isim,"calis"))
  {
   prog_calis(isim+6);
   argv=1;
   argc=(char **) malloc(sizeof(char *)*argv);
   argc[0]=(char *) malloc(10);
   strcpy(argc[0],"tamam");
  }
  else
  if (!strcmp(isim,"oldur"))
  {
   argv=1;
   argc=(char **) malloc(sizeof(char *)*argv);
   argc[0]=(char *) malloc(10);
   sscanf(isim+6," %ld",&handle);
   wind=turkpy.pencere_bul_parent(handle);
   if (wind!=NULL)
   {
    XKillClient(dpy,wind->alt_kisim);
    strcpy(argc[0],"tamam");
   }
   else
    strcpy(argc[0],"iptal");
  }
  else
  if (!strcmp(isim,"sonla"))
  {
   argv=1;
   argc=(char **) malloc(sizeof(char *)*argv);
   argc[0]=(char *) malloc(10);
   sscanf(isim+6," %ld",&handle);
   tus=turkpy.tus_bul(handle);
   if (tus!=NULL)
   {
    tus->tusa_bas(2);
    strcpy(argc[0],"tamam");
   }
   else
    strcpy(argc[0],"iptal");
  }
  else
  if (!strcmp(isim,"liste"))
  {
   argv=1;
   gecici_liste=pencere_listesi;
   while (gecici_liste->sonraki!=NULL)
   {
    if (gecici_liste->penc.baba)
     argv++;
    gecici_liste=gecici_liste->sonraki;
   }
   argc=(char **) malloc(sizeof(char *)*argv);
   argv=0;
   gecici_liste=pencere_listesi;
   while (gecici_liste->sonraki!=NULL)
   {
    if (gecici_liste->penc.baba && gecici_liste->penc.tuslar[1]!=None)
    {
     wind=turkpy.pencere_bul(gecici_liste->penc.pencereler[0]);
     argc[argv]=(char *) malloc(strlen(wind->baslik)+20);
     sprintf(argc[argv++],"%ld   %s",gecici_liste->penc.tuslar[1],wind->baslik);
    }
    gecici_liste=gecici_liste->sonraki;
   }
   argc[argv]=(char *) malloc(10);
   strcpy(argc[argv++],"tamam");
  }
  else
  {
   argv=1;
   argc=(char **) malloc(sizeof(char *)*argv);
   argc[0]=(char *) malloc(10);
   strcpy(argc[0],"iptal");
  }
  XSetCommand(dpy,turkpy.ana_pencere.handle,argc,argv);
  XFlush(dpy);
  for (say=0;say<argv;say++)
   free(argc[say]);
  free(argc);
  free(isim);
 }
 else
 {
  argv=1;
  argc=(char **) malloc(sizeof(char *)*argv);
  argc[0]=(char *) malloc(10);
  strcpy(argc[0],"iptal");
  XSetCommand(dpy,turkpy.ana_pencere.handle,argc,argv);
  XFlush(dpy);
  for (say=0;say<argv;say++)
   free(argc[say]);
  free(argc);
  free(isim);
 }
}

Bool menu_isim_varmi(char *isim)
{
 // Ayni isimde yaratilmis bir menu varsa bul ve haber ver...
 gecici_menu=menu_listesi;
 while (gecici_menu->sonraki!=NULL)
 {
  if (!strcmp(gecici_menu->penc.menu_adi,isim))
   return True;
  gecici_menu=gecici_menu->sonraki;
 }
 return False;
}

void menu_oku(TurkPY_Menu *menu)
{
 char dosya_adi[255],*veri,*veri2,menu_adi[80];
 // Donguyu baslat...
 do
 {
  // Komutu oku...
  fgets(dosya_adi,255,menu_dosya);
  if (dosya_adi[strlen(dosya_adi)-1]=='\n')
   dosya_adi[strlen(dosya_adi)-1]=0;
  // Komutu duzenle...
  veri=dosya_adi;
  while (veri[0]==' ')
   veri++;
  // Kapatma komutuysa menuyu kapat ve fonksiyondan cik...
  if (veri[0]=='}')
  {
   menu->sonlandir();
   return;
  }
  // Komut ile ismi birbirinden ayir...
  veri2=strstr(veri,",");
  veri[veri2-veri]=0;
  veri2++;
  // Komut yeni menu acma komutuysa ozyineleme ile yeni menuyu oku...
  if (veri2[0]=='{')
  {
   strcpy(menu_adi,veri);
   while (menu_isim_varmi(menu_adi))
    strcat(menu_adi,"X");
   strcat(veri," ->");
   menu_oku(turkpy.menu_yarat(menu_adi));
   menu->komut_ekle(veri,menu_adi,&alt_menu);
  }
  else
  // Yeni menu acma komutu degilse standart komutlara ekle...
   menu->komut_ekle(veri,veri2,&komut_calis);
 }
 while (veri[0]!='}');
 // Menuyu kapat...
 // NOT: Bu satira normal kosullarda hicbir zaman ulasilmaz...
 menu->sonlandir();
}

void TurkPY::kisayol_yukle(void)
{
 FILE *kisa_dosya;
 char dosya_adi[255],*veri,*veri2,*veri3;
 // ~/.efsane.kisayol dosyasini okumaya basla...
 sprintf(dosya_adi,"%s/.efsane.kisayol",getenv("HOME"));
 kisa_dosya=fopen(dosya_adi,"r");
 if (kisa_dosya==NULL)
  return;
 // Donguyu baslat...
 do
 {
  // Komutu oku...
  fgets(dosya_adi,255,kisa_dosya);
  if (dosya_adi[strlen(dosya_adi)-1]=='\n')
   dosya_adi[strlen(dosya_adi)-1]=0;
  // Komutu duzenle...
  veri=dosya_adi;
  while (veri[0]==' ')
   veri++;
  // Komutlar ile ismi birbirinden ayir...
  if (veri[0]!='}')
  {
   veri2=strstr(veri,",");
   veri[veri2-veri]=0;
   veri2++;
   veri3=strstr(veri2,",");
   veri2[veri3-veri2]=0;
   veri3++;
   kisayol_yarat(veri,veri2,veri3);
  }
 }
 while (veri[0]!='}');
 fclose(kisa_dosya);
}

void TurkPY::menu_yukle(void)
{
 char dosya_adi[255];
 // Favori menusunu baslat...
 favoriler_menu.ilk_komut=NULL;
 // ~/.efsane.menu dosyasini okumaya basla...
 sprintf(dosya_adi,"%s/.efsane.menu",getenv("HOME"));
 menu_dosya=fopen(dosya_adi,"r");
 if (menu_dosya==NULL)
  return;
 fgets(dosya_adi,255,menu_dosya);
 if (dosya_adi[strlen(dosya_adi)-1]=='\n')
  dosya_adi[strlen(dosya_adi)-1]=0;
 if (strcmp(dosya_adi,"Efsane.Menu,{"))
 {
  fclose(menu_dosya);
  return;
 }
 // Uygulamalar menusunu oku...
 menu_oku(&favoriler_menu);
 // ~/.efsane.menu dosyasini kapat ve islemi bitir...
 fclose(menu_dosya);
}

void TurkPY::verileri_yukle(void)
{
 XrmDatabase veriler;
 char dosya_adi[255],*deger_tipi,veri_adi[255];
 XrmValue deger_veri;
 int say1,say2,favorisay;
 // Veri tabani icin standart ayarlari yukle...
 apt=
 apr[0][0]=apr[0][1]=
 apr[1][0]=apr[1][1]=apr[1][2]=0;
 apr[0][2]=255;
 ppt=
 ppr[1][0]=ppr[1][1]=ppr[1][2]=0;
 ppr[0][0]=ppr[0][1]=ppr[0][2]=127;
 mur[0][0]=mur[0][1]=
 mur[1][0]=mur[1][1]=mur[1][2]=0;
 mut=1;
 mur[0][2]=255;
 cift_klik=250;
 menu_boyut_h=16;
 uzaktan_durum=favorisay=0;
 bilgi_goster=1;
 strcpy(uzaktan_sifre,"efsane");
 apd_isim[0]=ppd_isim[0]=mud_isim[0]=0;
 // Veri tabanini baslat...
 XrmInitialize();
 // Dosyayi ac...
 sprintf(dosya_adi,"%s/.efsane.ayarlar",getenv("HOME"));
 system("efsane_ayar");
 if ((veriler=XrmGetFileDatabase(dosya_adi))!=NULL)
 {
  // Dili tipini al...
  XrmGetResource(veriler,"efsane.dil","efsane.dil",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&dil_isim);
  // Bilgi tipini al...
  XrmGetResource(veriler,"bilgi.goster","bilgi.goster",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&bilgi_goster);
  // Menu boyutunu al...
  XrmGetResource(veriler,"menu.yukseklik","menu.yukseklik",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&menu_boyut_h);
  // Cift klikleme suresini al...
  XrmGetResource(veriler,"cift","cift",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&cift_klik);
  // Aktif Pencere boyama Tipini al...
  XrmGetResource(veriler,"apt","apt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&apt);
  // Pasif Pencere boyama Tipini al...
  XrmGetResource(veriler,"ppt","ppt",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&ppt);
  // Masa Ustu boyama Tipini al...
  XrmGetResource(veriler,"mut","mut",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&mut);
  // Aktif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"apd.isim","apd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&apd_isim);
  // Pasif Pencere boyama Dosya Ismini al...
  XrmGetResource(veriler,"ppd.isim","ppd.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&ppd_isim);
  // Masa Ustu boyama Dosya Ismini al...
  XrmGetResource(veriler,"mud.isim","mud.isim",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",&mud_isim);
  // Uzaktan Kumanda durumunu al...
  XrmGetResource(veriler,"uzaktan.durum","uzaktan.durum",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %d",&uzaktan_durum);
  // Uzaktan Kumanda sifresini al...
  XrmGetResource(veriler,"uzaktan.sifre","uzaktan.sifre",&deger_tipi,&deger_veri);
  if (deger_veri.addr)
   sscanf(deger_veri.addr," %s",uzaktan_sifre);
  for (say1=0;say1<2;say1++)
   for (say2=0;say2<3;say2++)
   {
    // Aktif Pencere boyama Rengini al...
    sprintf(veri_adi,"apr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&apr[say1][say2]);
    // Pasif Pencere boyama Rengini al...
    sprintf(veri_adi,"ppr%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&ppr[say1][say2]);
    // Masa Ustu boyama Rengini al...
    sprintf(veri_adi,"mur%d%d",say1,say2);
    XrmGetResource(veriler,veri_adi,veri_adi,&deger_tipi,&deger_veri);
    if (deger_veri.addr)
     sscanf(deger_veri.addr," %d",&mur[say1][say2]);
   }
  // Veri tabanini kapat...
  XrmDestroyDatabase(veriler);
 }
}

void TurkPY::durdur(void)
{
 // X Sunucusunun olay gondermemesini sagla...
 XGrabServer(dpy);
 XSync(dpy,False);
}

void TurkPY::harekete_gec(void)
{
 // X Sunucusu olay gondermeye tekrar baslasin...
 XUngrabServer(dpy);
}

TurkPY_Pencere *TurkPY::pencere_bul(Window handle)
{
 // handle ozelligi verilen pencereyi hafizada ara...
 gecici_liste=pencere_listesi;
 while (gecici_liste->penc.handle!=handle && gecici_liste->sonraki!=NULL)
  gecici_liste=gecici_liste->sonraki;
 return ((gecici_liste->sonraki!=NULL) ? &(gecici_liste->penc) : NULL);
}

TurkPY_Pencere *TurkPY::pencere_bul_focus(void)
{
 // son_focus ozelligi en buyuk olan pencereyi hafizada ara...
 TurkPY_Pencere *wind,*wind2;
 if (pencere_listesi->sonraki==NULL || ana_pencere.menu.menu_ekranda || favoriler_menu.menu_ekranda)
  return NULL;
 wind=&(pencere_listesi->penc);
 gecici_liste=pencere_listesi;
 while (gecici_liste->sonraki!=NULL)
 {
  if (gecici_liste->penc.baba && gecici_liste->penc.mapped &&
      (wind->son_focus<gecici_liste->penc.son_focus || !(wind->mapped) ||
       !(wind->baba)))
   wind=&(gecici_liste->penc);
  gecici_liste=gecici_liste->sonraki;
 }
 if (!(wind->mapped) || !(wind->baba))
  return NULL;
 wind2=pencere_bul_parent(wind->handle);
 return ((wind2!=NULL) ? ((wind2->menu.menu_ekranda) ? NULL : wind2) : ((wind->menu.menu_ekranda) ? NULL : wind));
}

int TurkPY::menu_komut_say(TurkPY_Menu *menu,char *baslik)
{
 // Komutun menu icindeki yerini bul...
 TurkPY_Menu_Komutu *komut;
 int say;
 komut=menu->ilk_komut;
 for (say=0;komut!=NULL;say++)
 {
  if (!strcmp(komut->calis_baslik,baslik))
   break;
  komut=komut->sonraki;
 }
 return (komut!=NULL) ? say : 0;
}

TurkPY_Menu *TurkPY::menu_bul_ust(Window handle)
{
 // handle ozelligi verilen alt menuyu hafizada ara...
 if (favoriler_menu.ust_menu==handle)
  return &favoriler_menu;
 gecici_menu=menu_listesi;
 while (gecici_menu->sonraki!=NULL)
 {
  if (gecici_menu->penc.ust_menu==handle && gecici_menu->penc.menu_ekranda)
   break;
  gecici_menu=gecici_menu->sonraki;
 }
 return ((gecici_menu->sonraki!=NULL) ? &(gecici_menu->penc) : NULL);
}

TurkPY_Menu *TurkPY::menu_bul_isim(char *isim)
{
 // handle ozelligi verilen alt menuyu hafizada ara...
 gecici_menu=menu_listesi;
 while (strcmp(gecici_menu->penc.menu_adi,isim) && gecici_menu->sonraki!=NULL)
  gecici_menu=gecici_menu->sonraki;
 return ((gecici_menu->sonraki!=NULL) ? &(gecici_menu->penc) : NULL);
}

TurkPY_Menu *TurkPY::menu_bul(Window handle)
{
 // handle ozelligi verilen menuyu hafizada ara...
 if (ana_pencere.menu.handle==handle)
  return &(ana_pencere.menu);
 if (favoriler_menu.handle==handle)
  return &favoriler_menu;
 gecici_liste=pencere_listesi;
 while (gecici_liste->penc.menu.handle!=handle && gecici_liste->sonraki!=NULL)
  gecici_liste=gecici_liste->sonraki;
 if (gecici_liste->sonraki!=NULL)
  return &(gecici_liste->penc.menu);
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->penc.menu.handle!=handle && gecici_ikon->sonraki!=NULL)
  gecici_ikon=gecici_ikon->sonraki;
 if (gecici_ikon->sonraki!=NULL)
  return &(gecici_ikon->penc.menu);
 gecici_menu=menu_listesi;
 while (gecici_menu->penc.handle!=handle && gecici_menu->sonraki!=NULL)
  gecici_menu=gecici_menu->sonraki;
 return ((gecici_menu->sonraki!=NULL) ? &(gecici_menu->penc) : NULL);
}

TurkPY_Ikon *TurkPY::menu_bul_parent_ikon(Window handle)
{
 // handle ozelligi verilen menuyu hafizada ara...
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->penc.menu.handle!=handle && gecici_ikon->sonraki!=NULL)
  gecici_ikon=gecici_ikon->sonraki;
 return ((gecici_ikon->sonraki!=NULL) ? &(gecici_ikon->penc) : NULL);
}

TurkPY_Pencere *TurkPY::menu_bul_parent(Window handle)
{
 // handle ozelligi verilen menuyu hafizada ara...
 gecici_liste=pencere_listesi;
 while (gecici_liste->penc.menu.handle!=handle && gecici_liste->sonraki!=NULL)
  gecici_liste=gecici_liste->sonraki;
 return ((gecici_liste->sonraki!=NULL) ? &(gecici_liste->penc) : NULL);
}

void TurkPY::pencere_oldur(Window handle)
{
 // handle ozelligi verilen pencereyi hafizadan at...
 pencere_liste_tipi *onceki,*gecici;
 onceki=NULL;
 gecici_liste=pencere_listesi;
 while (gecici_liste->penc.handle!=handle && gecici_liste->sonraki!=NULL)
 {
  onceki=gecici_liste;
  gecici_liste=gecici_liste->sonraki;
 }
 if (gecici_liste->sonraki==NULL) return;
 if (onceki!=NULL)
 {
  gecici=onceki->sonraki;
  onceki->sonraki=gecici->sonraki;
  free(gecici);
 }
 else
 {
  onceki=pencere_listesi;
  pencere_listesi=pencere_listesi->sonraki;
  free(onceki);
 }
}

void TurkPY::tus_oldur(Window handle)
{
 // handle ozelligi verilen tusu hafizadan at...
 tus_liste_tipi *onceki,*gecici;
 onceki=NULL;
 gecici_tus=tus_listesi;
 while (gecici_tus->penc.handle!=handle && gecici_tus->sonraki!=NULL)
 {
  onceki=gecici_tus;
  gecici_tus=gecici_tus->sonraki;
 }
 if (gecici_tus->sonraki==NULL) return;
 if (onceki!=NULL)
 {
  gecici=onceki->sonraki;
  onceki->sonraki=gecici->sonraki;
  free(gecici);
 }
 else
 {
  onceki=tus_listesi;
  tus_listesi=tus_listesi->sonraki;
  free(onceki);
 }
}

int ikon_diz(char *baslik,Window handle)
{
 // Ikonlari yeniden ekrana yerlestir...
 int ikonsay=0;
 menu_kapat(baslik,handle);
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->sonraki!=NULL)
 {
  gecici_ikon->penc.tekrar_yerlestir(ikonsay);
  ikonsay++;
  gecici_ikon=gecici_ikon->sonraki;
 }
}

void TurkPY::ikon_oldur(Window handle)
{
 // handle ozelligi verilen ikonu hafizadan at...
 ikon_liste_tipi *onceki,*gecici;
 onceki=NULL;
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->penc.handle!=handle && gecici_ikon->sonraki!=NULL)
 {
  onceki=gecici_ikon;
  gecici_ikon=gecici_ikon->sonraki;
 }
 if (gecici_ikon->sonraki==NULL) return;
 if (onceki!=NULL)
 {
  gecici=onceki->sonraki;
  onceki->sonraki=gecici->sonraki;
  free(gecici);
 }
 else
 {
  onceki=ikon_listesi;
  ikon_listesi=ikon_listesi->sonraki;
  free(onceki);
 }
}

void TurkPY::komut_oldur(Window handle)
{
 // handle ozelligi verilen menu komutunu hafizadan at...
 komut_liste_tipi *onceki,*gecici;
 onceki=NULL;
 gecici_komut=komut_listesi;
 while (gecici_komut->penc->handle!=handle && gecici_komut->sonraki!=NULL)
 {
  onceki=gecici_komut;
  gecici_komut=gecici_komut->sonraki;
 }
 if (gecici_komut->sonraki==NULL) return;
 if (onceki!=NULL)
 {
  gecici=onceki->sonraki;
  onceki->sonraki=gecici->sonraki;
  free(gecici);
 }
 else
 {
  onceki=komut_listesi;
  komut_listesi=komut_listesi->sonraki;
  free(onceki);
 }
}

TurkPY_Pencere *TurkPY::pencere_bul_parent(Window handle)
{
 // handle ozelligi verilen pencerenin babasini hafizada ara...
 int saydir,cik=0;
 gecici_liste=pencere_listesi;
 while (gecici_liste->sonraki!=NULL)
 {
  if (gecici_liste->penc.baba)
  {
   if (gecici_liste->penc.alt_kisim==handle) break;
   for (saydir=0;saydir<5;saydir++)
    if (gecici_liste->penc.tuslar[saydir]==handle) {cik=1;break;}
   for (saydir=0;saydir<2;saydir++)
    if (gecici_liste->penc.pencereler[saydir]==handle) {cik=1;break;}
  }
  if (cik) break;
  gecici_liste=gecici_liste->sonraki;
 }
 return ((gecici_liste->sonraki!=NULL) ? &(gecici_liste->penc) : NULL);
}

TurkPY_Menu *TurkPY::menu_yarat(char *isim)
{
 // Yeni bir menu yarat...
 TurkPY_Menu *menu;
 gecici_menu=menu_listesi;
 while (gecici_menu->sonraki!=NULL)
  gecici_menu=gecici_menu->sonraki;
 menu=&(gecici_menu->penc);
 gecici_menu->sonraki=(menu_liste_tipi *) malloc(sizeof(menu_liste_tipi));
 gecici_menu->sonraki->sonraki=NULL;
 menu->ilk_komut=NULL;
 menu->menu_ekranda=False;
 strcpy(menu->menu_adi,isim);
 return menu;
}

TurkPY_Pencere *TurkPY::kendin_pencere_yarat(int x,int y,int w,int h,Window handle,Bool baba,int tip)
{
 // Boyanabilecek yeni bir pencere yarat...
 TurkPY_Pencere *penc;
 gecici_liste=pencere_listesi;
 while (gecici_liste->sonraki!=NULL)
  gecici_liste=gecici_liste->sonraki;
 penc=&(gecici_liste->penc);
 gecici_liste->sonraki=(pencere_liste_tipi *) malloc(sizeof(pencere_liste_tipi));
 gecici_liste->sonraki->sonraki=NULL;
 penc->baba=baba;
 penc->init(x,y,w,h,handle,tip);
 return penc;
}

void TurkPY::tus_yarat(int x,int y,int tip,Window handle)
{
 // Yeni bir tus yarat...
 gecici_tus=tus_listesi;
 while (gecici_tus->sonraki!=NULL)
  gecici_tus=gecici_tus->sonraki;
 gecici_tus->sonraki=(tus_liste_tipi *) malloc(sizeof(tus_liste_tipi));
 gecici_tus->sonraki->sonraki=NULL;
 gecici_tus->penc.init(x,y,tip,handle);
}

void TurkPY::ikon_yarat(Window handle)
{
 // Yeni bir ikon yarat...
 int ikonsay=0,x,y;
 Bool dur=False;
 memset(ikonlar_durum,0,sizeof(ikonlar_durum));
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->sonraki!=NULL)
 {
  ikonsay++;
  ikonlar_durum[ikonX/ikon_boyu][ikonY/ikon_boyu]=1;
  ikonlar_durum[(ikonX+ikon_boyu-1)/ikon_boyu][ikonY/ikon_boyu]=1;
  ikonlar_durum[ikonX/ikon_boyu][(ikonY+ikon_boyu-1)/ikon_boyu]=1;
  ikonlar_durum[(ikonX+ikon_boyu-1)/ikon_boyu][(ikonY+ikon_boyu-1)/ikon_boyu]=1;
  gecici_ikon=gecici_ikon->sonraki;
 }
 for (y=(turkpy.ana_pencere.ozellik_pencere.height-ikon_boyu)/ikon_boyu;y>-1;y--)
 {
  for (x=0;x<turkpy.ikon_satir-1;x++)
   if (!ikonlar_durum[x][y])
   {
    dur=True;
    break;
   }
  if (dur)
   break;
 }
 gecici_ikon->sonraki=(ikon_liste_tipi *) malloc(sizeof(ikon_liste_tipi));
 gecici_ikon->sonraki->sonraki=NULL;
 gecici_ikon->penc.init(handle,ikonsay,x*ikon_boyu,y*ikon_boyu);
}

void TurkPY::kisayol_yarat(char *baslik1,char *baslik2,char *baslik3)
{
 // Yeni bir kisa yol yarat...
 int kisasay=0;
 gecici_kisayol=kisayol_listesi;
 while (gecici_kisayol->sonraki!=NULL)
 {
  kisasay++;
  gecici_kisayol=gecici_kisayol->sonraki;
 }
 if (kisasay>ana_pencere.ozellik_pencere.height/ikon_boyu)
  return;
 gecici_kisayol->sonraki=(kisayol_liste_tipi *) malloc(sizeof(kisayol_liste_tipi));
 gecici_kisayol->sonraki->sonraki=NULL;
 gecici_kisayol->penc.init(baslik1,baslik2,baslik3,kisasay);
}

TurkPY_Tus *TurkPY::tus_bul(Window handle)
{
 // handle ozelligi verilen tusu hafizada ara...
 gecici_tus=tus_listesi;
 while ((gecici_tus->penc.handle!=handle) && (gecici_tus->sonraki!=NULL))
  gecici_tus=gecici_tus->sonraki;
 return ((gecici_tus->sonraki!=NULL) ? &(gecici_tus->penc) : NULL);
}

TurkPY_Ikon *TurkPY::ikon_bul(Window handle)
{
 // handle ozelligi verilen ikonu hafizada ara...
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->penc.handle!=handle && gecici_ikon->penc.handle2!=handle && gecici_ikon->sonraki!=NULL)
  gecici_ikon=gecici_ikon->sonraki;
 return ((gecici_ikon->sonraki!=NULL) ? &(gecici_ikon->penc) : NULL);
}

TurkPY_Kisayol *TurkPY::kisayol_bul(Window handle)
{
 // handle ozelligi verilen kisa yolu hafizada ara...
 gecici_kisayol=kisayol_listesi;
 while (gecici_kisayol->penc.handle!=handle && gecici_kisayol->sonraki!=NULL)
  gecici_kisayol=gecici_kisayol->sonraki;
 return ((gecici_kisayol->sonraki!=NULL) ? &(gecici_kisayol->penc) : NULL);
}

TurkPY_Ikon *TurkPY::penc_ikon_bul(Window handle)
{
 // handle ozelligi verilen ikonu hafizada ara...
 gecici_ikon=ikon_listesi;
 while (gecici_ikon->penc.sahip!=handle && gecici_ikon->sonraki!=NULL)
  gecici_ikon=gecici_ikon->sonraki;
 return ((gecici_ikon->sonraki!=NULL) ? &(gecici_ikon->penc) : NULL);
}

TurkPY_Menu_Komutu *TurkPY::komut_bul(Window handle)
{
 // handle ozelligi verilen menu komutunu hafizada ara...
 gecici_komut=komut_listesi;
 while (gecici_komut->sonraki!=NULL && (gecici_komut->penc==NULL || gecici_komut->penc->handle!=handle))
  gecici_komut=gecici_komut->sonraki;
 return ((gecici_komut->sonraki!=NULL) ? gecici_komut->penc : NULL);
}

void TurkPY::komut_yarat(TurkPY_Menu_Komutu *komut)
{
 // Kendisi verilen menu komutunu sanal olarak yarat...
 gecici_komut=komut_listesi;
 while (gecici_komut->sonraki!=NULL)
  gecici_komut=gecici_komut->sonraki;
 gecici_komut->penc=komut;
 gecici_komut->sonraki=(komut_liste_tipi *) malloc(sizeof(komut_liste_tipi));
 gecici_komut->sonraki->sonraki=NULL;
}

void TurkPY::pencere_oynat(TurkPY_Pencere *wind,int yenix,int oncekix,int yeniy,int oncekiy)
{
 // Pencerenin koordinatlarini degistir...
 int pencerex,pencerey;
 XEvent olay;
 if (wind==NULL) return;
 durdur();
 pencerex=yenix-oncekix+wind->ozellik_pencere.x;
 pencerey=yeniy-oncekiy+wind->ozellik_pencere.y;
 XMoveWindow(dpy,wind->handle,pencerex,pencerey);
 /**********************************************************
  Uygulamanin babasi hareket ettigi icin kendi penceresi
  hareket etmez. Fakat uygulama babasini onemsemez ve yeni
  islerini eski koordinatlarina gore yapar. Bu yuzden su
  komutlari gondererek pencerenin hareket ettigini sanmasini
  sagliyoruz...
  **********************************************************/
 olay.type=ConfigureNotify;
 olay.xconfigure.display=dpy;
 olay.xconfigure.window=olay.xconfigure.event=wind->alt_kisim;
 olay.xconfigure.x=pencerex+1;
 olay.xconfigure.y=pencerey+1;
 olay.xconfigure.width=wind->ozellik_pencere.width-20;
 olay.xconfigure.height=wind->ozellik_pencere.height-20;
 olay.xconfigure.border_width=0;
 olay.xconfigure.above=wind->handle;
 olay.xconfigure.override_redirect=False;
 XSendEvent(dpy,wind->alt_kisim,False,StructureNotifyMask,&olay);
 wind->ozellik_pencere.x=pencerex;
 wind->ozellik_pencere.y=pencerey;
 harekete_gec();
}

void TurkPY::pencere_boyut(TurkPY_Pencere *wind,int x,int y,int w,int h,Bool son)
{
 // Pencerenin hem koordinatlarini hem de boyutlarini degistir...
 int pencerex,pencerey,xx,say;
 TurkPY_Pencere *wind2;
 TurkPY_Tus *tus2;
 char koor[15];
 XEvent olay;
 if (wind==NULL) return;
 durdur();
 if (son)
 {
  if (boyutbasla)
  {
   XDrawRectangle(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x,wind->ozellik_pencere.y,
      wind->ozellik_pencere.width,wind->ozellik_pencere.height);
   sprintf(koor,"%s: %d, %s: %d",yazi_al("EN"),wind->ozellik_pencere.width,yazi_al("BOY"),wind->ozellik_pencere.height);
   XDrawString(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x+5,
      wind->ozellik_pencere.y+wind->ozellik_pencere.height+20,koor,strlen(koor));
   XDrawRectangle(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x,wind->ozellik_pencere.y+wind->ozellik_pencere.height+1,
      XTextWidth(stdfnt,koor,strlen(koor))+10,24);
   boyutbasla=False;
  }
  wind->eskix=wind->ozellik_pencere.x;
  wind->eskiy=wind->ozellik_pencere.y;
  wind->eskiw=wind->ozellik_pencere.width;
  wind->eskih=wind->ozellik_pencere.height;
  XMoveResizeWindow(dpy,wind->handle,x,y,w,h);
  wind2=pencere_bul(wind->alt_kisim);
  if (wind2!=NULL)
  {
   XResizeWindow(dpy,wind->alt_kisim,w-20-wind2->ozellik_pencere.border_width*2,h-20-wind2->ozellik_pencere.border_width*2);
   XGetWindowAttributes(dpy,wind->alt_kisim,&(wind2->ozellik_pencere));
  }
  xx=1;
  degistir.y=h-20+2;
  for (say=0;say<5;say++)
   if (wind->tuslar[say]!=None)
   {
    xx+=18;
    tus2=tus_bul(wind->tuslar[say]);
    if (tus2!=NULL)
    {
     XConfigureWindow(dpy,tus2->handle,CWY,&degistir);
     XGetWindowAttributes(dpy,tus2->handle,&(tus2->ozellik_tus));
    }
   }
  degistir.width=w-xx-1;
  XConfigureWindow(dpy,wind->pencereler[0],CWWidth | CWY,&degistir);
  wind2=pencere_bul(wind->pencereler[0]);
  if (wind2!=NULL)
  {
   XGetWindowAttributes(dpy,wind2->handle,&(wind2->ozellik_pencere));
   XFreePixmap(dpy,wind2->arka_plan1);
   wind2->arka_plan1=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,0,0);
   XFreePixmap(dpy,wind2->arka_plan2);
   wind2->arka_plan2=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,0,1);
  }
  degistir.x=w-20+2;
  degistir.height=h-20+2;
  XConfigureWindow(dpy,wind->pencereler[1],CWX | CWHeight,&degistir);
  wind2=pencere_bul(wind->pencereler[1]);
  if (wind2!=NULL)
  {
   XGetWindowAttributes(dpy,wind2->handle,&(wind2->ozellik_pencere));
   XFreePixmap(dpy,wind2->arka_plan1);
   wind2->arka_plan1=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,1,0);
   XFreePixmap(dpy,wind2->arka_plan2);
   wind2->arka_plan2=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,1,1);
  }
  olay.type=ConfigureNotify;
  olay.xconfigure.display=dpy;
  olay.xconfigure.window=olay.xconfigure.event=wind->alt_kisim;
  olay.xconfigure.x=x+1;
  olay.xconfigure.y=y+1;
  olay.xconfigure.width=w-20;
  olay.xconfigure.height=h-20;
  olay.xconfigure.border_width=0;
  olay.xconfigure.above=wind->handle;
  olay.xconfigure.override_redirect=False;
  XSendEvent(dpy,wind->alt_kisim,False,StructureNotifyMask,&olay);
  wind->ozellik_pencere.x=x;
  wind->ozellik_pencere.y=y;
  wind->ozellik_pencere.width=w;
  wind->ozellik_pencere.height=h;
  wind->tekrar_boya();
 }
 else
 {
  if (boyutbasla)
  {
   XDrawRectangle(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x,wind->ozellik_pencere.y,
      wind->ozellik_pencere.width,wind->ozellik_pencere.height);
   sprintf(koor,"%s: %d, %s: %d",yazi_al("EN"),wind->ozellik_pencere.width,yazi_al("BOY"),wind->ozellik_pencere.height);
   XDrawString(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x+5,
      wind->ozellik_pencere.y+wind->ozellik_pencere.height+20,koor,strlen(koor));
   XDrawRectangle(dpy,kok_pencere,boyutGC,wind->ozellik_pencere.x,wind->ozellik_pencere.y+wind->ozellik_pencere.height+1,
      XTextWidth(stdfnt,koor,strlen(koor))+10,24);
  }
  else
   boyutbasla=True;
  wind->eskix=wind->ozellik_pencere.x;
  wind->eskiy=wind->ozellik_pencere.y;
  wind->eskiw=wind->ozellik_pencere.width;
  wind->eskih=wind->ozellik_pencere.height;
  XDrawRectangle(dpy,kok_pencere,boyutGC,x,y,w,h);
  sprintf(koor,"%s: %d, %s: %d",yazi_al("EN"),w,yazi_al("BOY"),h);
  XDrawString(dpy,kok_pencere,boyutGC,x+5,y+h+20,koor,strlen(koor));
  XDrawRectangle(dpy,kok_pencere,boyutGC,x,y+h+1,
     XTextWidth(stdfnt,koor,strlen(koor))+10,24);
  wind->ozellik_pencere.x=x;
  wind->ozellik_pencere.y=y;
  wind->ozellik_pencere.width=w;
  wind->ozellik_pencere.height=h;
 }
 harekete_gec();
}

TurkPY::olayi_uygula(XEvent *olay)
{
 // Fonksiyonda kullanilan degiskenler...
 int say,x,y,argc;
 char *isim,**argv;
 TurkPY_Pencere *wind2;
 XEvent olay2;
 // Olaylar...
 switch (olay->type)
 {
  case Expose:
   if (olay->xexpose.window==ana_pencere.handle) ana_pencere.paint();
   else
   {
    wind=pencere_bul(olay->xexpose.window);
    if (wind!=NULL)
    {
     if (!wind->prog_penceresi)
      wind->paint();
    }
    else
    {
     tus=tus_bul(olay->xexpose.window);
     if (tus!=NULL)
      tus->paint();
     else
     {
      ikon=ikon_bul(olay->xexpose.window);
      if (ikon!=NULL)
       ikon->paint();
      else
      {
       menu_komut=komut_bul(olay->xexpose.window);
       if (menu_komut!=NULL)
        menu_komut->paint();
       else
       {
        kisayol=kisayol_bul(olay->xexpose.window);
        if (kisayol!=NULL)
         kisayol->paint();
       }
      }
     }
    }
   }
   break;

  case FocusIn:
   durdur();
   wind=pencere_bul_parent(olay->xfocus.window);
   if (wind==NULL)
    wind=pencere_bul(olay->xfocus.window);
   if (wind!=NULL && wind!=focus_pencere)
   {
    if (focus_pencere!=NULL)
    {
     focus_pencere->focus=False;
     focus_pencere->tekrar_boya();
    }
    focus_pencere=wind;
    focus_pencere->focus=True;
    focus_pencere->tekrar_boya();
   }
   harekete_gec();
   break;

  case MapNotify:
   wind=pencere_bul_parent(olay->xmap.window);
   if (wind!=NULL)
   {
    durdur();
    if (!(wind->mapped))
    {
     wind->mapped=True;
     XMapWindow(dpy,wind->handle);
    }
    if (olay->xmap.window==wind->alt_kisim)
     eXRaiseWindow(dpy,wind);
    harekete_gec();
   }
   break;

  case UnmapNotify:
   wind=pencere_bul_parent(olay->xmap.window);
   if (wind!=NULL && wind->mapped)
   {
    wind->mapped=False;
    durdur();
    XUnmapWindow(dpy,wind->handle);
    harekete_gec();
   }
   eXRaiseWindow(dpy,pencere_bul_focus());
   break;

  case DestroyNotify:
   durdur();
   wind=pencere_bul_parent(olay->xdestroywindow.window);
   if (wind!=NULL)
   {
    ikon=penc_ikon_bul(wind->handle);
    if (ikon!=NULL)
    {
     XDestroyWindow(dpy,ikon->handle);
     XDestroyWindow(dpy,ikon->handle2);
     ikon_oldur(ikon->handle);
    }
    for (say=0;say<2;say++)
    {
     if (wind->pencereler[say]!=olay->xdestroywindow.window)
      XDestroyWindow(dpy,wind->pencereler[say]);
     wind2=pencere_bul(wind->pencereler[say]);
     if (wind2!=NULL)
     {
      XFreePixmap(dpy,wind2->arka_plan1);
      XFreePixmap(dpy,wind2->arka_plan2);
     }
     pencere_oldur(wind->pencereler[say]);
    }
    for (say=0;say<5;say++)
     if (wind->tuslar[say]!=None)
     {
      if (wind->tuslar[say]!=olay->xdestroywindow.window)
       XDestroyWindow(dpy,wind->tuslar[say]);
      tus_oldur(wind->tuslar[say]);
     }
    if (wind->handle!=olay->xdestroywindow.window)
     XDestroyWindow(dpy,wind->handle);
    pencere_oldur(wind->handle);
   }
   pencere_oldur(olay->xdestroywindow.window);
   harekete_gec();
   eXRaiseWindow(dpy,pencere_bul_focus());
   break;

  case MotionNotify:
   yenix=olay->xmotion.x_root;
   yeniy=olay->xmotion.y_root;
   if (oncekix!=yenix || oncekiy!=yeniy)
   {
    wind=pencere_bul_parent(olay->xmotion.window);
    if (wind==NULL)
    {
     wind=pencere_bul(olay->xmotion.window);
     if (wind!=NULL & wind->baba)
      wind=NULL;
    }
    if (wind!=NULL)
    {
     if (oynat)
      pencere_oynat(wind,yenix,oncekix,yeniy,oncekiy);
     else
     if (boyutlandir)
      pencere_boyut(wind,wind->ozellik_pencere.x+yenix-oncekix,wind->ozellik_pencere.y,
         wind->ozellik_pencere.width-yenix+oncekix,wind->ozellik_pencere.height+yeniy-oncekiy,False);
    }
    else
    {
     ikon=ikon_bul(olay->xmotion.window);
     if (ikon!=NULL)
      switch (oynat_ikon)
      {
       case 1:
        oynat_ikon=2;
        XDefineCursor(dpy,ikon->handle,hareket_kursor);
        XDefineCursor(dpy,ikon->handle2,hareket_kursor);
       case 2:
        ikon->yerlestir(yenix-oncekix+ikon->ozellik_pencere.x,yeniy-oncekiy+ikon->ozellik_pencere.y);
        break;
      }
    }
    oncekix=yenix;
    oncekiy=yeniy;
   }
   break;

  case ButtonRelease:
   switch (olay->xbutton.button)
   {
    case 1:
     if (olay->xbutton.window==ana_pencere.handle)
      favoriler_menu.init(olay->xbutton.x_root,olay->xbutton.y_root);
     else
     {
      tus=tus_bul(olay->xbutton.window);
      if (tus!=NULL)
       tus->tusa_bas(2);
      else
      {
       ikon=ikon_bul(olay->xbutton.window);
       if (ikon!=NULL)
       {
        if (oynat_ikon==2)
        {
         if (oncekix!=yenix || oncekiy!=yeniy)
          ikon->yerlestir(yenix-oncekix+ikon->ozellik_pencere.x,yeniy-oncekiy+ikon->ozellik_pencere.y);
         XDefineCursor(dpy,ikon->handle,normal_kursor);
         XDefineCursor(dpy,ikon->handle2,normal_kursor);
        }
        else
         ikon->tusa_bas(olay->xbutton.time);
        oynat_ikon=0;
       }
       else
       {
        menu_komut=komut_bul(olay->xbutton.window);
        if (menu_komut!=NULL && menu_komut->mapped)
         menu_komut->tusa_bas(menu_komut->calis_baslik,menu_komut->baba);
        else
        {
         kisayol=kisayol_bul(olay->xbutton.window);
         if (kisayol!=NULL)
          kisayol->tusa_bas(olay->xbutton.time);
         else
         {
          yenix=olay->xbutton.x_root;
          yeniy=olay->xbutton.y_root;
          if (oynat)
          {
           oynat=False;
           wind=pencere_bul_parent(olay->xbutton.window);
           if (wind==NULL)
            wind=pencere_bul(olay->xbutton.window);
           if (wind!=NULL)
           {
            if (oncekix!=yenix || oncekiy!=yeniy)
             pencere_oynat(wind,yenix,oncekix,yeniy,oncekiy);
            XDefineCursor(dpy,wind->handle,normal_kursor);
           }
          }
         }
        }
       }
      }
     }
     break;
    case 3:
     if (olay->xbutton.window==ana_pencere.handle)
      ana_pencere.menu.init(olay->xbutton.x_root,olay->xbutton.y_root);
     else
     {
      ikon=ikon_bul(olay->xbutton.window);
      if (ikon!=NULL)
       ikon->menu.init(olay->xbutton.x_root,olay->xbutton.y_root);
     }
     break;
   }
   break;

  case ButtonPress:
   if (olay->xbutton.button==1)
   {
    tus=tus_bul(olay->xbutton.window);
    if (tus!=NULL)
    {
     tus->tusa_bas(1);
     if (tus->tus_tipi==4)
     {
      oncekix=olay->xbutton.x_root;
      oncekiy=olay->xbutton.y_root;
     }
    }
    else
    {
     wind=pencere_bul_parent(olay->xbutton.window);
     if (wind==NULL)
     {
      wind=pencere_bul(olay->xbutton.window);
      if (wind!=NULL & wind->baba)
       wind=NULL;
     }
     if (wind!=NULL)
     {
      eXRaiseWindow(dpy,wind);
      if (!oynat && wind->alt_kisim!=olay->xbutton.window)
      {
       oynat=True;
       oncekix=olay->xbutton.x_root;
       oncekiy=olay->xbutton.y_root;
       XDefineCursor(dpy,wind->handle,hareket_kursor);
      }
     }
     else
     {
      ikon=ikon_bul(olay->xbutton.window);
      if (ikon!=NULL)
      {
       oncekix=olay->xbutton.x_root;
       oncekiy=olay->xbutton.y_root;
       oynat_ikon=1;
      }
     }
    }
   }
   break;

  case LeaveNotify:
   menu_komut=komut_bul(olay->xcrossing.window);
   if (menu_komut!=NULL)
    menu_komut->durum_degis(False);
   break;

  case EnterNotify:
   menu_komut=komut_bul(olay->xcrossing.window);
   if (menu_komut!=NULL)
    menu_komut->durum_degis(True);
   break;

  case PropertyNotify:
   if (olay->xproperty.state!=PropertyDelete)
   {
    if (olay->xproperty.atom==XA_WM_NAME)
    {
     if (olay->xproperty.window==ana_pencere.handle)
      uzaktan_kum();
     else
     {
      wind2=pencere_bul_parent(olay->xproperty.window);
      if (wind2!=NULL)
      {
       wind=pencere_bul(wind2->pencereler[0]);
       if (wind!=NULL)
       {
        isim=(char *) malloc(255);
        if (!XFetchName(dpy,olay->xproperty.window,&isim))
         wind->baslik[0]=0;
        else
         strcpy(wind->baslik,isim);
        free(isim);
        XSetWindowBackgroundPixmap(dpy,wind->handle,wind2->focus ? wind->arka_plan1 : wind->arka_plan2);
        XClearWindow(dpy,wind->handle);
        wind->paint();
       }
      }
     }
    }
   }
   break;

  case MapRequest:
   wind=pencere_bul(olay->xmaprequest.window);
   tus=tus_bul(olay->xmaprequest.window);
   ikon=ikon_bul(olay->xmaprequest.window);
   if (tus==NULL && wind==NULL && ikon==NULL)
   {
    if (XCheckTypedWindowEvent(dpy,olay->xmaprequest.window,DestroyNotify,&olay2))
     olayi_uygula(&olay2);
    else
    if (olay->xmaprequest.parent==kok_pencere)
     wind=pencere_yarat(olay->xmaprequest.window);
   }
   if (wind!=NULL)
    XMapWindow(dpy,wind->handle);
   if (tus!=NULL)
    XMapWindow(dpy,tus->handle);
   if (ikon!=NULL)
   {
    XMapWindow(dpy,ikon->handle);
    XMapWindow(dpy,ikon->handle2);
   }
   break;

  case ClientMessage:
   if (olay->xclient.message_type==atom_durum_degis &&
       olay->xclient.format==32 && olay->xclient.data.l[0]==IconicState)
   {
    durdur();
    wind=turkpy.pencere_bul_parent(olay->xclient.window);
    if (wind!=NULL)
     ikon_yarat(wind->handle);
    harekete_gec();
   }
   break;

  case ConfigureRequest:
   durdur();
   degistir.x=degistir.y=1;
   degistir.border_width=0;
   degistir.sibling=olay->xconfigurerequest.above;
   degistir.stack_mode=olay->xconfigurerequest.detail;
   degistir.width=olay->xconfigurerequest.width;
   degistir.height=olay->xconfigurerequest.height;
   wind=pencere_bul(olay->xconfigurerequest.window);
   if (wind!=NULL)
   {
    XConfigureWindow(dpy,wind->handle,olay->xconfigurerequest.value_mask & valmask,&degistir);
    XGetWindowAttributes(dpy,wind->handle,&(wind->ozellik_pencere));
    degistir.x=olay->xconfigurerequest.x;
    degistir.y=olay->xconfigurerequest.y;
   }
   else
   {
    degistir.x=olay->xconfigurerequest.x;
    degistir.y=olay->xconfigurerequest.y;
    XConfigureWindow(dpy,olay->xconfigurerequest.window,olay->xconfigurerequest.value_mask,&degistir);
   }
   wind=pencere_bul_parent(olay->xconfigurerequest.window);
   if (wind!=NULL)
   {
    degistir.width=olay->xconfigurerequest.width+20;
    degistir.height=olay->xconfigurerequest.height+20;
    XConfigureWindow(dpy,wind->handle,olay->xconfigurerequest.value_mask & valmask,&degistir);
    XGetWindowAttributes(dpy,wind->handle,&(wind->ozellik_pencere));
    if (olay->xconfigurerequest.value_mask & CWHeight || olay->xconfigurerequest.value_mask & CWWidth)
    {
     x=1;
     degistir.y=olay->xconfigurerequest.height+2;
     for (say=0;say<5;say++)
      if (wind->tuslar[say]!=None)
      {
       x+=18;
       XConfigureWindow(dpy,wind->tuslar[say],CWY,&degistir);
      }
     degistir.width=olay->xconfigurerequest.width+20-x-1;
     XConfigureWindow(dpy,wind->pencereler[0],CWWidth | CWY,&degistir);
     wind2=pencere_bul(wind->pencereler[0]);
     if (wind2!=NULL)
     {
      XGetWindowAttributes(dpy,wind2->handle,&(wind2->ozellik_pencere));
      XFreePixmap(dpy,wind2->arka_plan1);
      wind2->arka_plan1=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,0,0);
      XFreePixmap(dpy,wind2->arka_plan2);
      wind2->arka_plan2=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,0,1);
      XSetWindowBackgroundPixmap(dpy,wind2->handle,wind->focus ? wind2->arka_plan1 : wind2->arka_plan2);
      XClearWindow(dpy,wind2->handle);
      wind2->paint();
     }
     degistir.x=olay->xconfigurerequest.width+2;
     degistir.height=olay->xconfigurerequest.height+2;
     XConfigureWindow(dpy,wind->pencereler[1],CWX | CWHeight,&degistir);
     wind2=pencere_bul(wind->pencereler[1]);
     if (wind2!=NULL)
     {
      XGetWindowAttributes(dpy,wind2->handle,&(wind2->ozellik_pencere));
      XFreePixmap(dpy,wind2->arka_plan1);
      wind2->arka_plan1=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,1,0);
      XFreePixmap(dpy,wind2->arka_plan2);
      wind2->arka_plan2=boya(wind2->ozellik_pencere.width,wind2->ozellik_pencere.height,wind2->handle,1,1);
      XSetWindowBackgroundPixmap(dpy,wind2->handle,wind->focus ? wind2->arka_plan1 : wind2->arka_plan2);
      XClearWindow(dpy,wind2->handle);
      wind2->paint();
     }
    }
   }
   harekete_gec();
   break;
 }
}

TurkPY_Pencere *TurkPY::pencere_yarat(Window handle)
{
 pencere_liste_tipi *gecici;
 gecici_liste=pencere_listesi;
 while (gecici_liste->sonraki!=NULL)
  gecici_liste=gecici_liste->sonraki;
 gecici=gecici_liste;
 gecici_liste->sonraki=(pencere_liste_tipi *) malloc(sizeof(pencere_liste_tipi));
 gecici_liste=gecici_liste->sonraki;
 gecici_liste->sonraki=NULL;
 gecici->penc.initprog(handle);
 return &(gecici->penc);
}

void TurkPY::donguye_gir(void)
{
 XEvent olay;
 shutdown=False;
 fprintf(stderr,"\n%s\n\n%s: %s\n\n",infostr,dil_isim,yazi_al("AUTHOR"));
 while (!shutdown)
 {
  XNextEvent(dpy,&olay);
  olayi_uygula(&olay);
 }
 XFreeFont(dpy,stdfnt);
 // Dil secimini bitir...
 lang_bitir();
}

Bool TurkPY::kontrol_et(Window hand,Bool dur)
{
 XEvent olay;
 if (XCheckTypedWindowEvent(dpy,hand,DestroyNotify,&olay))
 {
  olayi_uygula(&olay);
  if (dur)
   harekete_gec();
  return False;
 }
 return True;
}

void eXRaiseWindow(Display *dpy,TurkPY_Pencere *wind)
{
 if (wind==NULL) return;
 XRaiseWindow(dpy,wind->handle);
 if (wind->baba && turkpy.kontrol_et(wind->alt_kisim,False))
 {
  wind->son_focus=++focus_say;
  XSetInputFocus(dpy,wind->alt_kisim,RevertToParent,CurrentTime);
 }
}

