/***********************\
*  Efsane 0.6.0         *
*  Sistem Modulu        *
*  Baslik (.h) Dosyasi  *
\***********************/

#include <X11/Xlib.h>
#include <X11/Xresource.h>
#include <X11/xpm.h>

#include "pencere.h"
#include "tus.h"
#include "boya.h"
#include "ikon.h"
#include "kisayol.h"
#include "dil.h"

#define infostr "Efsane 0.6.0 Beta - Serdar Ozler, 1998-1999"
#define infolen strlen(infostr)
#define tus_boyu 17
#define ikon_boyu 64

#define scr DefaultScreen(dpy)
#define kok_pencere DefaultRootWindow(dpy)
#define gorsellik DefaultVisual(dpy,scr)
#define derinlik DefaultDepth(dpy,scr)

#define fonk_hepsi            (1l << 0)
#define fonk_resize           (1l << 1)
#define fonk_minimize         (1l << 3)
#define fonk_maximize         (1l << 4)
#define dekor_hepsi           (1l << 0)
#define dekor_resize          (1l << 1)
#define dekor_minimize        (1l << 5)
#define dekor_maximize        (1l << 6)

extern Display *dpy;
extern int siyah,beyaz,menu_boyut_h,bilgi_goster;
extern TurkPY_AnaPencere ana_pencere;
extern XWindowAttributes ozellik_kok_pencere;
extern GC boyutGC;
extern XFontStruct *stdfnt;
extern Atom atom_protokol,atom_yok_et;
extern Bool boyutlandir,shutdown;
extern TurkPY_Menu favoriler_menu;
extern Pixmap ikon_resim;

typedef struct pencere_liste_tipi {
 TurkPY_Pencere penc;
 pencere_liste_tipi *sonraki;
};

typedef struct tus_liste_tipi {
 TurkPY_Tus penc;
 tus_liste_tipi *sonraki;
};

typedef struct ikon_liste_tipi {
 TurkPY_Ikon penc;
 ikon_liste_tipi *sonraki;
};

typedef struct kisayol_liste_tipi {
 TurkPY_Kisayol penc;
 kisayol_liste_tipi *sonraki;
};

typedef struct komut_liste_tipi {
 TurkPY_Menu_Komutu *penc;
 komut_liste_tipi *sonraki;
};

typedef struct menu_liste_tipi {
 TurkPY_Menu penc;
 menu_liste_tipi *sonraki;
};

extern pencere_liste_tipi *pencere_listesi;
extern tus_liste_tipi *tus_listesi;
extern ikon_liste_tipi *ikon_listesi;
extern kisayol_liste_tipi *kisayol_listesi;
extern komut_liste_tipi *komut_listesi;
extern menu_liste_tipi *menu_listesi;
extern TurkPY_Pencere *focus_pencere;

class TurkPY
{
public:
       TurkPY_AnaPencere ana_pencere;
       Cursor normal_kursor,hareket_kursor,buyukluk_kursor;
       int apt,apr[2][3],ppt,ppr[2][3],mut,mur[2][3],ikon_satir,cift_klik;
       Pixmap tus_arka_plan1,tus_arka_plan2,kisayol_arka_plan;
       unsigned long ikon_arka_plan;
       char apd_isim[160],ppd_isim[160],mud_isim[160],dil_isim[30];
       XrmDatabase lang;
       init(void);
       olayi_uygula(XEvent *);
       void donguye_gir(void);
       void durdur(void);
       void harekete_gec(void);
       void tus_yarat(int,int,int,Window);
       void ikon_yarat(Window);
       void kisayol_yarat(char *,char *,char *);
       void komut_yarat(TurkPY_Menu_Komutu *);
       void pencere_oldur(Window);
       void tus_oldur(Window);
       void komut_oldur(Window);
       void ikon_oldur(Window);
       void pencere_oynat(TurkPY_Pencere *,int,int,int,int);
       void pencere_boyut(TurkPY_Pencere *,int,int,int,int,Bool);
       void verileri_yukle(void);
       void menu_yukle(void);
       void kisayol_yukle(void);
       Bool kontrol_et(Window,Bool);
       int menu_komut_say(TurkPY_Menu *,char *);
       TurkPY_Tus *tus_bul(Window);
       TurkPY_Ikon *ikon_bul(Window);
       TurkPY_Ikon *penc_ikon_bul(Window);
       TurkPY_Ikon *menu_bul_parent_ikon(Window);
       TurkPY_Menu *menu_bul(Window);
       TurkPY_Menu *menu_bul_ust(Window);
       TurkPY_Menu *menu_bul_isim(char *);
       TurkPY_Menu *menu_yarat(char *);
       TurkPY_Menu_Komutu *komut_bul(Window);
       TurkPY_Kisayol *kisayol_bul(Window);
       TurkPY_Pencere *pencere_yarat(Window);
       TurkPY_Pencere *kendin_pencere_yarat(int,int,int,int,Window,Bool,int);
       TurkPY_Pencere *pencere_bul(Window);
       TurkPY_Pencere *pencere_bul_focus(void);
       TurkPY_Pencere *pencere_bul_parent(Window);
       TurkPY_Pencere *menu_bul_parent(Window);
};

extern TurkPY turkpy;

void eXRaiseWindow(Display *,TurkPY_Pencere *);

int komut_calis(char *,Window);
void prog_calis(char *);
int ikon_diz(char *,Window);

